(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)

program affiche;
  uses crt;
  type t_string_2= string[2];
       t_string_4= string[4];
       t_string_80= string[80];
  var g_choix: char;
      g_nom_fichier_objet: t_string_80;
      g_adresse_debut, g_adresse_fin: integer;
      g_a_charge_objet: boolean;
      g_tampon: array[$0..$7FFF] of byte;
      g_sortie: text;
      g_nom_sortie: t_string_80;

  function f_octet_hexadecimal(p_octet: byte): t_string_2;
    const vi_hexa: array[0..15] of char= '0123456789ABCDEF';
    begin
      f_octet_hexadecimal:= concat(vi_hexa[p_octet div 16],
                                      vi_hexa[p_octet mod 16]);
    end; 

  function f_entier_hexadecimal(p_entier: integer): t_string_4;
    begin
      f_entier_hexadecimal:= concat(f_octet_hexadecimal(hi(p_entier)),
                                    f_octet_hexadecimal(lo(p_entier)));
    end; 

  procedure choisis_sortie(var pv_sortie: text; var pv_nom_sortie: t_string_80);
    begin
      write('nom sortie: <a:essai.txt> ? '); readln(pv_nom_sortie);
      if pv_nom_sortie= ''
        then pv_nom_sortie:= 'CON';
      writeln(pv_sortie); close(pv_sortie);
      assign(pv_sortie, pv_nom_sortie);
      (*$i-*)
      rewrite(pv_sortie);
      (*$i+*)
      if ioresult<> 0
        then begin
            write('pas pu ouvrir '+ pv_nom_sortie);
            pv_nom_sortie:= 'CON';
            assign(pv_sortie, pv_nom_sortie);
            (*$i-*)
            rewrite(pv_sortie);
          end;
      writeln(pv_sortie);
    end; 

  procedure charge_objet;
    var l_fichier_objet: file;
        l_bloc_debut, l_bloc_fin, l_nombre_blocs: integer;
        l_fin: integer;
    begin
      assign(l_fichier_objet, g_nom_fichier_objet);
      (*$i-*)
      reset(l_fichier_objet, $0100);
      (*$i+*)
      if ioresult<> 0
        then begin
            writeln('pas de fichier ', g_nom_fichier_objet, '. exit');
            close(l_fichier_objet);
            exit;
          end;
      l_nombre_blocs:= filesize(l_fichier_objet);
      writeln('NOMBRES BLOCS 256: ', l_nombre_blocs);
      if l_nombre_blocs> $80
        then begin
            if (g_adresse_debut<> 0) or (g_adresse_fin<> 0)
              then begin
                  l_bloc_debut:= (g_adresse_debut) shr 8;
                  l_bloc_fin:= (g_adresse_fin) shr 8;
                  if g_adresse_fin and $00FF<> 0
                    then l_bloc_fin:= l_bloc_fin+ 1;
                  l_nombre_blocs:= l_bloc_fin- l_bloc_debut;
                  if l_nombre_blocs> $80
                    then begin
                        writeln('ne peut pas charger tout l''objet');
                        writeln('utilisez une plus petite plage debut/fin');
                        close(l_fichier_objet);
                        exit;
                      end
                    else
                      if l_bloc_debut<> 0
                        then seek(l_fichier_objet, l_bloc_debut);
                end 
              else begin
                  writeln('ne peut pas charger tout l''objet');
                  writeln('prcisez l''adresse de debut et de fin');
                  close(l_fichier_objet);
                  exit;
                end;
          end; 
      fillchar(g_tampon, sizeof(g_tampon), 0);
      blockread(l_fichier_objet, g_tampon, l_nombre_blocs);
      close(l_fichier_objet);
      g_adresse_fin:= l_nombre_blocs* $0100- 1;
      g_a_charge_objet:= true;
    end; 

  procedure affiche_tampon;
    var l_colonne: integer;
        l_indice_debut, l_indice_tampon, l_alignement: integer;
        l_quantite: integer;
        l_octet: byte;
    begin 
      if not g_a_charge_objet
        then charge_objet;
      l_indice_debut:= g_adresse_debut and $FF00;
      l_alignement:= g_adresse_debut and $0007;
      l_indice_tampon:= g_adresse_debut and $00F8;
      l_quantite:= g_adresse_fin- (g_adresse_debut and $FF00)+ 1;
      while l_quantite> 0 do
      begin
        write(g_sortie, '$', f_entier_hexadecimal(l_indice_tampon+ l_indice_debut), ': ');
        if l_alignement> 0
          then begin
              write(g_sortie, '': 4*l_alignement);
              l_colonne:= l_alignement;
            end
          else l_colonne:= 0;
        while (l_colonne<= 7) and (l_quantite- l_colonne> 0) do
        begin
          l_octet:= g_tampon[l_indice_tampon+ l_colonne];
          write(g_sortie, '$', f_octet_hexadecimal(l_octet), ' ');
          l_colonne:= l_colonne+ 1;
        end;
        write(g_sortie, '': 4* (8- l_colonne), ':');
        if l_alignement> 0
          then begin
              write(g_sortie, '': l_alignement);
              l_colonne:= l_alignement;
              l_alignement:= 0;
            end
          else l_colonne:= 0;
        while (l_colonne<= 7) and (l_quantite- l_colonne> 0) do
        begin
          l_octet:= g_tampon[l_indice_tampon+ l_colonne];
          if l_octet in [32..127]
            then write(g_sortie, chr(l_octet))
            else write(g_sortie, '.');
          l_colonne:= l_colonne+ 1;
        end;
        writeln(g_sortie);
        if (l_indice_tampon+ l_colonne) mod $100= 0
          then writeln(g_sortie);
        l_quantite:= l_quantite- 8;
        l_indice_tampon:= l_indice_tampon+ 8;
      end; 
    end; 

  procedure initialise;
    begin
      g_nom_sortie:= '';
      assign(g_sortie, g_nom_sortie);
      rewrite(g_sortie);
      g_nom_fichier_objet:= 'B:CLIENTS.DBF';
      g_a_charge_objet:= false;
      g_adresse_debut:= $0000;
      g_adresse_fin:= $7FFF;
    end; 

  begin 
    initialise;
    repeat
      writeln;
      write(g_nom_fichier_objet, ' $', f_entier_hexadecimal(g_adresse_debut));
      write('-$', f_entier_hexadecimal(g_adresse_fin));
      write(' ', g_adresse_fin, ' ');
      writeln(' -> ', g_nom_sortie);
      write('Nom, Dbut, Fin, Charge, Affiche, Sortie, Quitte ? ');
      g_choix:= readkey; writeln(g_choix);
      g_choix:= upcase(g_choix);
      case g_choix of
       'A' : affiche_tampon;
       'C' : charge_objet;
       'D' : begin
               write('adresse debut <$1234> ? '); readln(g_adresse_debut);
             end;
       'F' : begin
               write('adresse fin   <$2345> ? '); readln(g_adresse_fin);
             end;
       'N' : begin
               write('nom fichier <a:essai.com> ? ');
               readln(g_nom_fichier_objet);
             end;
       'S' : choisis_sortie(g_sortie, g_nom_sortie);
      end; 
    until g_choix= 'Q';
    close(g_sortie);
  end. 
