(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)

program affiche_contenu_des_fichiers_d_etiquettes;
  uses crt;
  type t_string_80= string[80];
  (*$i a:isortie *)
  var g_choix: char;
      g_nom_etiquette: t_string_80;

  procedure affiche_chaine_0(var pv_chaine_0; var pv_taille: integer);
    var l_chaine_surtypee: array[0..255] of char absolute pv_chaine_0;
        l_indice_chaine: integer;
    begin
      l_indice_chaine:= 0;
      while l_chaine_surtypee[l_indice_chaine]<> chr(0) do
      begin
        write(g_sortie, l_chaine_surtypee[l_indice_chaine]);
        l_indice_chaine:= l_indice_chaine+ 1;
      end;
      pv_taille:= l_indice_chaine;
    end; 

  procedure affiche_fichier_etiquette;
    type t_etiquette= record
                        signature: byte;
                        format: array[0..59] of char;
                        largeur_etiquette: integer;
                        hauteur_etiquette: integer;
                        marge_gauche: integer;
                        lignes_entre_etiquettes: integer;
                        colonnes_entre_etiquettes: integer;
                        etiquettes_par_ligne: integer;
                        tableau_colonnes: array[0..15] of array[0..59] of char;
                        signature_2: byte;
                      end;
    var l_etiquette: file of t_etiquette;
        l_fiche_etiquette: t_etiquette;
        l_numero_colonne: integer;
    begin 
      assign(l_etiquette, g_nom_etiquette+ '.LBL');
      reset(l_etiquette);
      read(l_etiquette, l_fiche_etiquette);
      with l_fiche_etiquette do
      begin
        writeln(g_sortie, 'largeur:                   ', largeur_etiquette);
        writeln(g_sortie, 'hauteur etiquette:         ', hauteur_etiquette);
        writeln(g_sortie, 'marge gauche:              ', marge_gauche);
        writeln(g_sortie, 'lignes entre etiquettes:   ', lignes_entre_etiquettes);
        writeln(g_sortie, 'colonnes entre etiquettes: ', colonnes_entre_etiquettes);
        writeln(g_sortie, 'etiquettes par ligne:      ', etiquettes_par_ligne);
        l_numero_colonne:= 0;
        while tableau_colonnes[l_numero_colonne, 0]<> chr(signature) do
        begin
          writeln(g_sortie, l_numero_colonne, ' ', tableau_colonnes[l_numero_colonne]);
          l_numero_colonne:= l_numero_colonne+ 1;
        end; 
      end; 
      close(l_etiquette);
    end; 

  procedure entre_nom_fichier;
    begin
      write(g_sortie, 'nom fichier <CLIENT> ?'); readln(g_nom_etiquette);
    end; 

  procedure initialise;
    begin
      g_nom_etiquette:= 'A:CLIENTS';
      initialise_sortie;
    end; 

  begin 
    initialise;
    repeat
      writeln;
      writeln(g_nom_etiquette, ' -> ', g_nom_sortie);
      write('Nom, Affiche, Sortie, Quitte ? ');
      g_choix:= upcase(readkey); writeln(g_choix);
      case g_choix of
        'A' : affiche_fichier_etiquette;
        'N' : entre_nom_fichier;
        'S' : choisis_sortie;
      end;
    until g_choix= 'Q';
    ferme_sortie;
  end. 
