(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)

program creation_et_listage;
  uses dos, crt,
       utypcons, uchained;
  const k_descripteur_zone_fin= 4;
  type t_fiche_d_base= record
                         effacee: char;
                         prenom: array[0..14] of char;
                         fait_du_pascal: char;
                         poids: array[0..12] of char;
                         date_de_naissance: array[0..7] of char;
                         fin_fiche: array[0..3] of char;
                       end;
  var g_choix: char;
  (*$i a:idonnees *)

  procedure cree;
    begin
      cree_fichier_donnees(g_nom_donnees);
      with g_fichier_donnees do
      begin
        ajoute_definition_de_zone(0, 'PRENOM',    'C', sizeof(fiche_courante.prenom), 0);
        ajoute_definition_de_zone(1, 'PASCALIEN', 'L', 1, 0);
        ajoute_definition_de_zone(2, 'POIDS',     'N', sizeof(fiche_courante.poids), 4);
        ajoute_definition_de_zone(3, 'NAISSANCE', 'D', 8, 0);
        ajoute_definition_de_zone(4, 'FIN',       'C', sizeof(fiche_courante.fin_fiche), 0);
      end; 
      ferme_fichier_donnees;
    end; 

  procedure genere;
    var l_numero: integer;

    procedure remplis_fiche(p_numero, p_caractere: char);
      begin
        with g_fichier_donnees.fiche_courante do
        begin
          fillchar(prenom, sizeof(prenom), p_caractere);
          fait_du_pascal:= 'Y';
          fillchar(poids, sizeof(poids), p_numero); poids[8]:= '.';
          fillchar(date_de_naissance, sizeof(date_de_naissance), p_numero);
          fillchar(fin_fiche, sizeof(fin_fiche), p_caractere);
        end;
      end; 

    begin 
      ouvre_fichier_donnees(g_nom_donnees);
      for l_numero:= 0 to 7 do
      begin
        remplis_fiche(chr(48+ (l_numero mod 10)), chr(65+ l_numero));
        ecris_fiche_courante;
      end;
      ferme_fichier_donnees;
    end; 

  procedure liste;

    procedure affiche_fiche;
      var l_chaine: string;
          l_reel: real;
          l_erreur: integer;
      begin
        with g_fichier_donnees.fiche_courante do
        begin
          write(f_numero_fiche_courante- 1: 3, ' >');
          convertis_chaine_db_en_string(prenom, sizeof(prenom), l_chaine);
          write(l_chaine, ' ');
          convertis_chaine_db_en_reel(poids, sizeof(poids), l_reel, l_erreur);
          write(l_reel: 14: 4, ' ');
          convertis_chaine_db_en_string(fait_du_pascal, 1, l_chaine);
          write(l_chaine, ' ');
          convertis_chaine_db_en_string(date_de_naissance, 8, l_chaine);
          write(l_chaine, ' ');
          convertis_chaine_db_en_string(fin_fiche, sizeof(fin_fiche), l_chaine);
          write(l_chaine, ' ');
          writeln('<');
        end; 
      end; 

    begin 
      ouvre_fichier_donnees(g_nom_donnees);
      while not f_fin_fichier_donnees do
      begin
        lis_fiche_courante;
        affiche_fiche;
      end; 
      ferme_fichier_donnees;
    end; 

  procedure initialise;
    begin 
      g_nom_donnees:= 'A:CLIENTS';
    end; 

  begin 
    initialise;
    repeat
      writeln;
      write('Cree, Gnre, Liste, Quitte ? ');
      g_choix:= readkey; writeln(g_choix);
      case g_choix of
        ' ' : clrscr;
        'c' : cree;
        'l' : liste;
        'g' : genere;
      end;
    until g_choix= 'q';
  end. 
