(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)

program gestion_variable;
  uses crt,
       utypcons,
       uclavier, uerreur,
       uecran, uaffiche, usaisis,
       udonnees, uchamps, usaisfic,
       uexgest;
  var g_choix: char;

  procedure saisis_simple;
    var l_choix: char;

    procedure saisis_les_zones;
      var l_numero_zone: integer;
          l_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
          l_ligne, l_colonne: integer;
          l_gabarit: t_gabarit_max;
      begin
        initialise_fiche_courante(g_pt_fichier_donnees);
        clrscr;
        l_ligne:= 1; l_colonne:= 1;
        for l_numero_zone:= 0 to f_nombre_zones(g_pt_fichier_donnees)- 1 do
        begin
          l_gabarit:= '';
          l_pt_descripteur_de_zone:=
              f_pt_descripteur_zone(g_pt_fichier_donnees, l_numero_zone);
          with l_pt_descripteur_de_zone^ do
            case type_zone of
              'C' : saisis_chaine_db(l_ligne, l_colonne, 0,
                      taille_zone, pt_valeur_zone^, l_gabarit, 'C');
              'N' : saisis_chaine_db_numerique(l_ligne, l_colonne, 0,
                      taille_zone, decimales_zone, taille_zone, decimales_zone,
                      pt_valeur_zone^, l_gabarit);
              'L' : saisis_booleen(l_ligne, l_colonne, 0, pt_valeur_zone^[0]);
              'D' : saisis_chaine_db_date(l_ligne, l_colonne, 0,
                        taille_zone, pt_valeur_zone^, l_gabarit);
            end; 
          writeln;
          if l_ligne< 25
            then l_ligne:= l_ligne+ 1;
        end; 
      end; 

    begin 
      ouvre_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
      positionne_fiche_courante(g_pt_fichier_donnees, f_nombre_fiches(g_pt_fichier_donnees));
      repeat
        saisis_les_zones;
        ecris_fiche_courante(g_pt_fichier_donnees);
        write('Continue, Quitte ? '); lis_touche(l_choix);
      until l_choix= 'q';
      ferme_fichier_donnees(g_pt_fichier_donnees);
    end; 

  procedure initialise;
    begin 
      g_nom_fichier:= 'A:CLIENTS.DBF';
    end; 

  begin 
    initialise;
    repeat
      writeln;
      writeln(g_nom_fichier);
      writeln('Nom, Cre, Affiche en-tte,');
      write('Gnre, Saisie standard, saIsie simple, Liste, ');
      write('sOrtie, Quitte ? ');
      lis_touche(g_choix); writeln(g_choix);
      case g_choix of
        ' ' : clrscr;
        'a' : affiche_descripteur_DBF;
        'c' : cree_DBF;
        'g' : genere_DBF(9);
        'l' : liste_DBF;
        's' : saisis_DBF;
        'i' : saisis_simple;
        'n' : begin
                write('nom du fichier <A:CLIENTS> ? ');
                readln(g_nom_fichier);
              end;
      end;
    until g_choix= 'q';
  end. 
