(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+,v-*)

program affiche_fichiers_index;
  uses dos, crt;
  type t_string_80= string[80];
       t_string_255= string[255];
  (*$i a:isortie *)
  var g_choix: char;
      g_nom_index: t_string_80;

  procedure affiche_chaine_0_max(var pv_chaine_0; var pv_taille: integer);
    var l_chaine_surtypee: array[0..255] of char absolute pv_chaine_0;
        l_indice_chaine: integer;
    begin
      l_indice_chaine:= 0;
      while (l_indice_chaine< pv_taille)
          and (l_chaine_surtypee[l_indice_chaine]<> chr(0)) do
      begin
        write(g_sortie, l_chaine_surtypee[l_indice_chaine]);
        l_indice_chaine:= l_indice_chaine+ 1;
      end;
      pv_taille:= l_indice_chaine;
    end; 

  procedure affiche_fichier_index;
    type t_date= record
                   annee, mois, jour: byte;
                 end;
         t_descripteur_index= record 
                                secteur_debut: longint;
                                nom_tag: array[0..10] of char;
                                v_taille_descripteur: byte;
                                zero_1: byte;
                                numero: byte;
                                v_2, v_3: byte;
                                type_zone: char;
                                fin: array[21..31] of char;
                              end;
         t_en_tete_index_multiple= record
                                     numero_fichier: byte;
                                     date_1: t_date;
                                     nom_base: array[0..9] of byte;
                                     zero_1: array[14..19] of byte;
                                     deux: byte;
                                     zero_2: array[21..22] of byte;
                                     inconnu2: array[23..26] of byte;
                                     zero_3: byte;
                                     nombre_index: byte;
                                     zero_4: array[29..31] of byte;
                                     secteur_suivant: longint;
                                     zero_5: array[36..43] of byte;
                                     date_2: t_date;
                                     fin: array[47..$1FF] of byte;
                                     table_descripteur: array[0..15] of t_descripteur_index;
                                   end;
        t_en_tete_un_index= record 
                              numero_secteur_racine: longint;
                              nombre_secteurs: longint;
                              v_1: byte;
                              type_zone: char;
                              zero_1: word;
                              taille_cle: word;
                              nombre_cle_par_secteur_max: word;
                              zero_2: word;
                              taille_cellule: word;
                              v_2: word;
                              zero_3: word;
                              expression_cle: array[0..9] of char;
                              zero_4: array[$0822..$08F7] of byte;
                              numero_premier_secteur: longint;
                              numero_dernier_secteur: longint;
                              zero_5: byte;
                              date: t_date;
                              zero_6: array[$0904..$09DB] of byte;
                              v_3: word;
                              zero_7: word;
                              nombre_colonnes_cle: word;
                              table_colonnes: array[0..0] of
                                record
                                  nom_colonne: array[0..9] of char;
                                  zero_8: array[0..16] of byte;
                                  ascendant: char;
                                end;
                              zero_9: array[$09FE..$0BFF] of byte;
                            end;
         t_cellule= record
                      numero_page: longint;
                      cle: array[0..0] of char;
                    end;
         t_page_index= record
                         nombre_cles: longint;
                         secteur_de_la_page_precedente: longint;
                         table_positions_cellules: array[0..503] of byte;
                       end;
         t_page= record
                   case integer of
                     1 : (en_tete_index_multiple: t_en_tete_index_multiple);
                     2 : (en_tete_un_index: t_en_tete_un_index);
                     3 : (page: t_page_index);
                 end;
    var l_index_multiple: file of t_page;
        l_page: t_page;
        l_en_tete_index_multiple: t_page;
        l_taille_nom: integer;
        l_numero_index: integer;

    procedure affiche_index(p_secteur: word);
      var l_en_tete_un_index: t_page;
          l_colonne: integer;
          l_taille_expression, l_taille_nom: integer;

      procedure affiche_page(p_numero_secteur, p_taille_cellule: word;
           p_taille_cle: integer);
        var l_page: t_page;
            l_cellule: integer;

        procedure affiche_cellules(var p_position);
          var l_cellule: t_cellule absolute p_position;
          begin
            with l_cellule do
            begin
              write(g_sortie, numero_page: 3, ' ');
              if p_taille_cle> 8
                then p_taille_cle:= 8;
              affiche_chaine_0_max(cle, p_taille_cle);
            end; 
          end; 

        begin 
          while p_numero_secteur<> 0 do
          begin
            writeln(g_sortie, p_numero_secteur);
            seek(l_index_multiple, p_numero_secteur div 2);
            read(l_index_multiple, l_page);
            with l_page.page do
            begin
              write(g_sortie, '        ');
              for l_cellule:= 1 to nombre_cles do
              begin
                (*$r-*)
                affiche_cellules(table_positions_cellules[p_taille_cellule* (l_cellule- 1)]);
                (*$r+*)
              end;
              writeln(g_sortie);
              p_numero_secteur:= secteur_de_la_page_precedente;
            end; 
          end; 
        end; 

      begin 
        seek(l_index_multiple, p_secteur div 2);
        read(l_index_multiple, l_en_tete_un_index);
        with l_en_tete_un_index.en_tete_un_index do
        begin
          writeln(g_sortie, '    racine: ', numero_secteur_racine);
          writeln(g_sortie, '    nombre secteurs: ', nombre_secteurs);
          writeln(g_sortie, '    type zone: ', type_zone);
          writeln(g_sortie, '    taille cl: ', taille_cle);
          writeln(g_sortie, '    nombre cle max: ', nombre_cle_par_secteur_max);
          writeln(g_sortie, '    taille cellule: ', taille_cellule);
          write(g_sortie, '    expression cl: '); l_taille_expression:= 10;
          affiche_chaine_0_max(expression_cle, l_taille_expression); writeln(g_sortie);
          writeln(g_sortie, '    numero premier secteur: ', numero_premier_secteur);
          writeln(g_sortie, '    numero dernier secteur: ', numero_dernier_secteur);
          writeln(g_sortie, '    nombre colonnes ', nombre_colonnes_cle);
          (*$r-*)
          for l_colonne:= 0 to nombre_colonnes_cle- 1 do
            with table_colonnes[l_colonne] do
            (*$r+*)
            begin
              write(g_sortie, '      zone: ');
              l_taille_nom:= 10;
              affiche_chaine_0_max(nom_colonne, l_taille_nom); writeln(g_sortie);
              writeln(g_sortie, '      ascendant: ', ascendant);
            end; 
          affiche_page(numero_dernier_secteur, taille_cellule, taille_cle);
        end; 
      end; 

    begin 
      assign(l_index_multiple, g_nom_index+ '.MDX');
      reset(l_index_multiple);
      read(l_index_multiple, l_en_tete_index_multiple);
      with l_en_tete_index_multiple.en_tete_index_multiple do
      begin
        writeln(g_sortie, 'type fichier: ', numero_fichier);
        with date_1 do
          writeln(g_sortie, 'date;         ', annee, '-', mois, '-', jour);
        write  (g_sortie, 'nom fichier:      ');
        l_taille_nom:= 10;
        affiche_chaine_0_max(nom_base, l_taille_nom); writeln(g_sortie);
        writeln(g_sortie, 'nombre index:   ', nombre_index);
        writeln(g_sortie, 'secteur suivant:   ', secteur_suivant);
        for l_numero_index:= 1 to nombre_index do
          with table_descripteur[l_numero_index] do
          begin
            writeln(g_sortie, '  secteur dbut: ', secteur_debut: 3, ', nom tag: ', nom_tag,
                ', type zone: ', type_zone);
            affiche_index(secteur_debut);
          end; 
      end; 
    end; 

  procedure entre_nom_base;
    begin
      write(g_sortie, 'nom fichier <CLIENT> ? '); readln(g_nom_index);
    end; 

  procedure initialise;
    begin
      g_nom_index:= 'A:CLIENT4';
      initialise_sortie;
    end; 

  begin 
    initialise;
    repeat
      writeln;
      writeln(g_nom_index, ' -> ', g_nom_sortie);
      write('Nom, Affiche, Sortie, Quitte ? ');
      g_choix:= upcase(readkey); writeln(g_choix);
      case g_choix of
        'A' : affiche_fichier_index;
        'N' : entre_nom_base;
        'S' : choisis_sortie;
      end;
    until g_choix= 'Q';
    ferme_sortie;
  end. 
