(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)

program affiche_contenu_des_fichier_memoire;
  uses crt;
  type t_string_80= string[80];
  (*$i a:isortie *)
  var g_choix: char;
      g_nom_memoire: t_string_80;

  procedure affiche_chaine_0(var pv_chaine_0; var pv_taille: integer);
    var l_chaine_surtypee: array[0..255] of char absolute pv_chaine_0;
        l_indice_chaine: integer;
    begin
      l_indice_chaine:= 0;
      while l_chaine_surtypee[l_indice_chaine]<> chr(0) do
      begin
        write(g_sortie, l_chaine_surtypee[l_indice_chaine]);
        l_indice_chaine:= l_indice_chaine+ 1;
      end;
      pv_taille:= l_indice_chaine;
    end; 

  procedure affiche_fichier_memoire;
    const k_entier= $CE;  
          k_chaine= $C3;  
          k_booleen= $CC; 
          k_date= $C4;    
    type t_nom= array[0..10] of char;
         t_variable= record
                       nom: t_nom;
                       type_variable: byte;
                       adresse1, adresse2: integer;
                       case integer of
                         k_entier: (colonnes_entier, decimales: byte;
                                    remplissage_1: byte;
                                    remplissage_2: array[0..12] of byte;
                                    valeur: array[0..7] of byte);
                         k_chaine: (colonnes_chaine: byte;
                                    remplissage_3, remplissage_4: byte;
                                    remplissage_5: array[0..12] of byte;
                                    chaine: byte);
                         k_booleen : (colonnes_booleen: byte;
                                      remplissage_6, remplissage_7: byte;
                                      remplissage_8: array[0..12] of byte;
                                      booleen: boolean);
                         k_date : (colonnes_date: byte);
                     end;
    var l_memoire: file;
        l_tampon: array[0..1024] of byte;
        l_indice_memoire, l_longueur_chaine_0, l_fin_memoire: integer;

    procedure affiche_variable(var pv_variable; var pv_taille: integer);
      var l_variable_surtypee: t_variable absolute pv_variable;
      begin 
        with l_variable_surtypee do
        begin
          affiche_chaine_0(nom, l_longueur_chaine_0); write(g_sortie, '': 11- l_longueur_chaine_0);
          case type_variable of
            k_entier : begin
                         writeln(g_sortie, 'colonnes: ', colonnes_entier,
                             ', decimales: ', decimales);
                         pv_taille:= 40;
                       end;
            k_chaine : begin
                         write(g_sortie, 'colonnes: ', colonnes_chaine, ' ');
                         affiche_chaine_0(chaine, l_longueur_chaine_0); writeln(g_sortie);
                         pv_taille:= 32+ colonnes_chaine;
                       end;
            k_booleen : begin
                          write(g_sortie, 'colonnes: ', colonnes_booleen);
                          if booleen
                            then writeln(g_sortie, ' .T.')
                            else writeln(g_sortie, ' .F.');
                          pv_taille:= 33;
                        end;
            k_date : begin
                       writeln(g_sortie);
                       pv_taille:= 40;
                     end;
            else
              writeln('inconnu');
              pv_taille:= 40;
          end; 
        end; 
      end; 

    begin 
      assign(l_memoire, g_nom_memoire+ '.MEM');
      reset(l_memoire, 1);
      l_fin_memoire:= filesize(l_memoire);
      blockread(l_memoire, l_tampon, l_fin_memoire);
      l_indice_memoire:= 0;
      writeln(g_sortie, 'indice:     nom:    paramtres:');
      while l_indice_memoire< l_fin_memoire- 1 do
      begin
        write(g_sortie, l_indice_memoire: 6, '   ');
        affiche_variable(l_tampon[l_indice_memoire], l_longueur_chaine_0);
        l_indice_memoire:= l_indice_memoire+ l_longueur_chaine_0;
      end; 
      close(l_memoire);
    end; 

  procedure entre_nom_fichier;
    begin
      write(g_sortie, 'nom fichier <CLIENT> ?'); readln(g_nom_memoire);
    end; 

  procedure initialise;
    begin
      g_nom_memoire:= 'A:VARIABLE';
      initialise_sortie;
    end; 

  begin 
    initialise;
    repeat
      writeln;
      writeln(g_nom_memoire, ' -> ', g_nom_sortie);
      write('Nom, Affiche, Sortie, Quitte ? ');
      g_choix:= upcase(readkey); writeln(g_choix);
      case g_choix of
        'A' : affiche_fichier_memoire;
        'N' : entre_nom_fichier;
        'S' : choisis_sortie;
      end;
    until g_choix= 'Q';
    ferme_sortie;
  end. 
