(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+,v-*)

program affiche_contenu_du_fichier_rapport;
  uses crt;
  type t_string_80= string[80];
  (*$i a:isortie *)
  var g_choix: char;
      g_nom_rapport: t_string_80;

  procedure affiche_chaine_0(var pv_chaine_0);
    var l_chaine_surtypee: array[0..255] of char absolute pv_chaine_0;
        l_indice_chaine: integer;
    begin
      l_indice_chaine:= 0;
      while l_chaine_surtypee[l_indice_chaine]<> chr(0) do
      begin
        write(g_sortie, l_chaine_surtypee[l_indice_chaine]);
        l_indice_chaine:= l_indice_chaine+ 1;
      end;
    end; 

  procedure affiche_fichier_rapport;
    type t_parametre_zone= record
                             nombre_colonnes: integer;
                             remplissage_1: integer;
                             replissage_2: byte;
                             avec_total: char;
                             nombre_decimales: integer;
                             numero_colonne: integer;
                             numero_titre: integer;
                           end;
         t_fiche_rapport= record
                            signature: integer;
                            taille_definition: integer;
                            tableau_tailles_definitions: array[0..54] of integer;
                            tableau_decalages_definitions: array[0..54] of integer;
                            tableau_definitions: array[0..243] of byte;
                            remplissage_1: array[0..1207] of byte;
                            tableau_parametres_zones: array[0..23] of t_parametre_zone;
                            remplissage_2: integer;
                            numero_sous_total_1: integer;
                            numero_titre_sous_total_1: integer;
                            numero_sous_total_2: integer;
                            numero_titre_sous_total_2: integer;
                            largeur_etat, lignes_par_page: integer;
                            marge_gauche, marge_droite: integer;
                            interlignes: integer;
                            ejection_avant, ejection_apres, pleine_page: char;
                          end;
    var l_rapport: file of t_fiche_rapport;
        l_fiche_rapport: t_fiche_rapport;
        l_numero_definition, l_nombre_definitions: integer;
        l_numero_zone: integer;

    procedure affiche_sous_total(p_numero: integer);
      begin
        if p_numero<> -1
          then
            with l_fiche_rapport do
            begin
              affiche_chaine_0(tableau_definitions[tableau_decalages_definitions[p_numero]]);
              write(g_sortie, ' --- ');
              l_nombre_definitions:= l_nombre_definitions- 1;
            end;
      end; 

    begin 
      assign(l_rapport, g_nom_rapport+ '.FRM');
      reset(l_rapport);
      read(l_rapport, l_fiche_rapport);
      with l_fiche_rapport do
      begin
        writeln(g_sortie, 'signature:           ', signature);
        writeln(g_sortie, 'taille dfinition:   ', taille_definition);
        write  ('taille dfinitions:  ');
        l_numero_definition:= 0;
        while tableau_tailles_definitions[l_numero_definition]<> 0 do
        begin
          write(g_sortie, tableau_tailles_definitions[l_numero_definition]: 4);
          l_numero_definition:= l_numero_definition+ 1;
        end;
        writeln(g_sortie);
        l_nombre_definitions:= l_numero_definition;
        write  ('dbut dfinitions:   ');
        for l_numero_definition:= 0 to l_nombre_definitions- 1 do
          write(g_sortie, tableau_decalages_definitions[l_numero_definition]: 4);
        writeln(g_sortie);
        write(g_sortie, 'titres: ');
        l_numero_definition:= 0;
        repeat
          affiche_chaine_0(tableau_definitions[tableau_decalages_definitions[l_numero_definition]]);
          write(g_sortie, ' --- ');
          l_numero_definition:= l_numero_definition+ 1;
        until l_numero_definition>= l_nombre_definitions;
        writeln(g_sortie);
        write(g_sortie, 'titres sous-totaux: ');
        affiche_sous_total(numero_sous_total_1);
        affiche_sous_total(numero_titre_sous_total_1);
        affiche_sous_total(numero_sous_total_2);
        affiche_sous_total(numero_titre_sous_total_2);
        writeln(g_sortie);
        l_numero_zone:= 0;
        writeln(g_sortie, 'numro largeur total dcimales numro numro');
        writeln(g_sortie, '                                zone  titre');
        repeat
          write(g_sortie, l_numero_zone: 5);
          with tableau_parametres_zones[l_numero_zone] do
          begin
            write(g_sortie, nombre_colonnes: 8, avec_total: 6, nombre_decimales:7,
                numero_colonne: 9, numero_titre: 8);
            if numero_titre<> -1
              then l_nombre_definitions:= l_nombre_definitions- 1;
            writeln(g_sortie);
          end;
          l_numero_zone:= l_numero_zone+ 1;
        until l_numero_zone>= l_nombre_definitions- 1;
        writeln(g_sortie, 'largeur tat:        ', largeur_etat);
        writeln(g_sortie, 'lignes par page:     ', lignes_par_page);
        writeln(g_sortie, 'marge gauche:        ', marge_gauche);
        writeln(g_sortie, 'marge droite:        ', marge_droite);
        writeln(g_sortie, 'interlignes:         ', interlignes);
        writeln(g_sortie, 'jection avant:      ', ejection_avant);
        writeln(g_sortie, 'jection aprs:      ', ejection_apres);
        writeln(g_sortie, 'pleine page:         ', pleine_page);
      end; 
      close(l_rapport);
    end; 

  procedure entre_nom_fichier;
    begin
      write(g_sortie, 'nom fichier <CLIENT> ? '); readln(g_nom_rapport);
    end; 

  procedure initialise;
    begin
      g_nom_rapport:= 'A:CLIENTS';
      initialise_sortie;
    end; 

  begin 
    initialise;
    repeat
      writeln;
      writeln(g_nom_rapport, ' -> ', g_nom_sortie);
      write('Nom, Affiche, Sortie, Quitte ? ');
      g_choix:= upcase(readkey); writeln(g_choix);
      case g_choix of
        'A' : affiche_fichier_rapport;
        'N' : entre_nom_fichier;
        'S' : choisis_sortie;
      end;
    until g_choix= 'Q';
    ferme_sortie;
  end. 
