(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)

program saisie_format_connu;
  uses dos, crt,
       utypcons,
       uclavier, uerreur,
       uchained,
       uecran, uaffiche,
       usaisis;
  const k_descripteur_zone_fin= 4;
  type t_fiche_d_base= record
                         effacee: char;
                         prenom: array[0..14] of char;
                         fait_du_pascal: char;
                         poids: array[0..12] of char;
                         date_de_naissance: array[0..7] of char;
                         fin_fiche: array[0..3] of char;
                       end;
  var g_choix: char;
  (*$i a:idonnees *)
  (*$i a:ichamps *)
  (*$i a:isaisfic *)

  procedure cree;
    begin
      cree_fichier_donnees(g_nom_donnees);
      with g_fichier_donnees do
      begin
        ajoute_definition_de_zone(0, 'PRENOM',    'C', sizeof(fiche_courante.prenom), 0);
        ajoute_definition_de_zone(1, 'PASCALIEN', 'L', 1, 0);
        ajoute_definition_de_zone(2, 'POIDS',     'N', sizeof(fiche_courante.poids), 4);
        ajoute_definition_de_zone(3, 'NAISSANCE', 'D', 8, 0);
        ajoute_definition_de_zone(4, 'FIN',       'C', sizeof(fiche_courante.fin_fiche), 0);
      end; 
      ferme_fichier_donnees;
    end; 

  procedure saisis_standard;
    var l_numero_fiche: longint;
    begin 
      ouvre_fichier_donnees(g_nom_donnees);
      initialise_le_masque_standard;
      l_numero_fiche:= f_nombre_fiches;
      saisis_fiche_a_fiche(l_numero_fiche);
      ferme_fichier_donnees;
    end; 

  procedure saisis_format_special;
    var l_numero_fiche: longint;

    procedure initialise_le_masque;
      begin 
        initialise_groupe_de_champs;
        with g_fichier_donnees.fiche_courante do
        begin
          initialise_champ_et_titre(0, 0, 2,  18, sizeof(prenom),   0, 'XAZA!!!A ##9ZZA',
              'XAZA!!!A ##9ZZA');
          initialise_champ_et_titre(1, 0, 3,  18, 1,                0, '', '');
          initialise_champ_et_titre(2, 0, 4,  18, sizeof(poids),    4, '#####.###,#', '####.###,#');
          initialise_champ_et_titre(3, 1, 2, 28,  8,                0, '', '');
          initialise_champ_et_titre(4, 1, 3, 28, sizeof(fin_fiche), 0, '', '');
        end;
      end; 

    begin 
      ouvre_fichier_donnees(g_nom_donnees);
      initialise_le_masque;
      l_numero_fiche:= f_nombre_fiches;
      saisis_fiche_a_fiche(l_numero_fiche);
      ferme_fichier_donnees;
    end; 

  procedure liste;

    procedure affiche_fiche;
      var l_chaine: string;
          l_reel: real;
          l_erreur: integer;
      begin
        with g_fichier_donnees.fiche_courante do
        begin
          write(f_numero_fiche_courante- 1: 3, ' >');
          convertis_chaine_db_en_string(prenom, sizeof(prenom), l_chaine);
          write(l_chaine, ' ');
          convertis_chaine_db_en_reel(poids, sizeof(poids), l_reel, l_erreur);
          write(l_reel: 14: 4, ' ');
          convertis_chaine_db_en_string(fait_du_pascal, 1, l_chaine);
          write(l_chaine, ' ');
          convertis_chaine_db_en_string(date_de_naissance, 8, l_chaine);
          write(l_chaine, ' ');
          convertis_chaine_db_en_string(fin_fiche, sizeof(fin_fiche), l_chaine);
          write(l_chaine, ' ');
          writeln('<');
        end; 
      end; 

    begin 
      ouvre_fichier_donnees(g_nom_donnees);
      while not f_fin_fichier_donnees do
      begin
        lis_fiche_courante;
        affiche_fiche;
      end; 
      ferme_fichier_donnees;
    end; 

  procedure initialise;
    begin 
      g_nom_donnees:= 'A:CLIENTS';
    end; 

  begin 
    initialise;
    repeat
      writeln;
      write('Cree, Saisie standard, saisie Particulire, Liste, Quitte ? ');
      g_choix:= readkey; writeln(g_choix);
      case g_choix of
        ' ' : clrscr;
        'c' : cree;
        's' : saisis_standard;
        'p' : saisis_format_special;
        'l' : liste;
      end;
    until g_choix= 'q';
  end. 
