(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
unit uexindex;
  interface
    uses crt,
         utypcons,
         udonnees,
         uindex, uexgest;
    var g_index: t_index;
        g_nom_index: t_string_80;

    procedure cree_un_index(p_numero_zone: integer);

    procedure construis_index(p_numero_zone: integer);

    procedure liste_indexee;
  implementation

    procedure cree_un_index(p_numero_zone: integer);
      begin
        ouvre_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
        with f_pt_descripteur_zone(g_pt_fichier_donnees, p_numero_zone)^ do
          cree_index(g_index, g_nom_index, taille_zone, t_nom_variable(nom_zone));
        ferme_fichier_donnees(g_pt_fichier_donnees);
        ferme_index(g_index);
      end; 

    procedure construis_index(p_numero_zone: integer);
      var l_numero_fiche: integer;
          l_numero_zone: integer;
          l_cle_db: t_cle_db;
      begin
        ouvre_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
        l_numero_fiche:= 0;
        ouvre_index(g_index, g_nom_index);
        while not f_fin_fichier_donnees(g_pt_fichier_donnees) do
        begin
          lis_fiche_courante(g_pt_fichier_donnees);
          write(l_numero_fiche: 6, ' ');
          for l_numero_zone:= 0 to f_nombre_zones(g_pt_fichier_donnees)- 1 do
          begin
            affiche_zone(g_pt_fichier_donnees, l_numero_zone);
            write('=');
          end;
          writeln('<');
          with f_pt_descripteur_zone(g_pt_fichier_donnees, p_numero_zone)^ do
            move(pt_valeur_zone^, l_cle_db, taille_zone);
          ajoute_cle(g_index, l_cle_db, l_numero_fiche);
          l_numero_fiche:= l_numero_fiche+ 1;
        end; 
        ferme_fichier_donnees(g_pt_fichier_donnees);
        ferme_index(g_index);
      end; 

    procedure liste_indexee;
      var l_numero_fiche: longint;
          l_numero_zone: integer;
          l_cle_db: t_cle_db;
          l_a_trouve: boolean;
      begin
        ouvre_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
        ouvre_index(g_index, g_nom_index);
        fillchar(l_cle_db, sizeof(t_cle_db), 0);
        cherche_cle(g_index, l_cle_db, l_numero_fiche, l_a_trouve);
        writeln(l_numero_fiche);
        while (l_numero_fiche>= 0) do
        begin
          positionne_fiche_courante(g_pt_fichier_donnees, l_numero_fiche);
          lis_fiche_courante(g_pt_fichier_donnees);
          write(l_numero_fiche: 6, ' ');
          for l_numero_zone:= 0 to f_nombre_zones(g_pt_fichier_donnees)- 1 do
          begin
            affiche_zone(g_pt_fichier_donnees, l_numero_zone);
            write('=');
          end;
          writeln('<');
          cherche_cle_suivante(g_index, l_numero_fiche);
        end; 
        ferme_fichier_donnees(g_pt_fichier_donnees);
        ferme_index(g_index);
      end; 

   begin 
   end. 


