(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
unit usortie;
  interface
    uses uclavier, uerreur,
         uchained;
    type t_sortie= record
                     sortie: text;
                     nom_sortie: string;
                     ligne_sortie, colonne_sortie: integer;
                   end;
    var g_sortie: t_sortie;

    procedure va_a_la_ligne;

    procedure va_a_la_marge;

    procedure positionne_sortie(p_ligne, p_colonne: integer);

    procedure imprime_chaine_db(var pv_valeur; p_taille: integer);

    procedure imprime_chaine_db_ligne(var pv_valeur; p_taille: integer);

    procedure initialise_sortie(p_nom_sortie: string);

    procedure choisis_sortie;

    procedure ferme_sortie;
  implementation

    procedure va_a_la_ligne;
      begin
        with g_sortie do
        begin
          writeln(sortie);
          ligne_sortie:= ligne_sortie+ 1;
          colonne_sortie:= 1;
        end; 
      end; 

    procedure va_a_la_marge;
      begin
        with g_sortie do
        begin
          write(sortie, k_return);
          colonne_sortie:= 1;
        end; 
      end; 

    procedure positionne_sortie(p_ligne, p_colonne: integer);
      var l_colonne: integer;
      begin
        with g_sortie do
        begin
          while p_ligne> ligne_sortie do
            va_a_la_ligne;
          if p_colonne< colonne_sortie
            then begin
                sonne;
                for l_colonne:= p_colonne to colonne_sortie- 1 do
                  write(sortie, k_efface_avant_curseur);
                colonne_sortie:= p_colonne;
              end
            else
              if p_colonne> colonne_sortie
                then begin
                  write(sortie, '': p_colonne- colonne_sortie);
                  colonne_sortie:= p_colonne;
                end;
        end; 
      end; 

    procedure imprime_chaine_db(var pv_valeur; p_taille: integer);
      var l_chaine: string;
      begin
        with g_sortie do
        begin
          convertis_chaine_db_en_string(pv_valeur, p_taille, l_chaine);
          write(sortie, l_chaine);
          colonne_sortie:= colonne_sortie+ p_taille;
        end; 
      end; 

    procedure imprime_chaine_db_ligne(var pv_valeur; p_taille: integer);
      begin
        imprime_chaine_db(pv_valeur, p_taille);
        va_a_la_ligne;
      end; 

    procedure initialise_sortie(p_nom_sortie: string);
      begin
        with g_sortie do
        begin
          nom_sortie:= p_nom_sortie;
          assign(sortie, p_nom_sortie);
          rewrite(sortie);
          ligne_sortie:= 1; colonne_sortie:= 1;
        end;
      end; 

    procedure ferme_sortie;
      begin
        close(g_sortie.sortie);
      end; 

    procedure choisis_sortie;
      var l_choix: char;
      begin
        with g_sortie do
        begin
          ferme_sortie;
          write('Ecran, Imprimante, Fichier ? ');
          lis_touche(l_choix); writeln(l_choix);
          case l_choix of
            'e' : nom_sortie:= 'CON';
            'i' : nom_sortie:= 'LPT1';
            'f' : begin
                    write('nom <a:resu.pas> ? ');
                    readln(nom_sortie);
                  end;
            else affiche_erreur('pas cette sortie');
          end; 
          initialise_sortie(nom_sortie);
        end; 
      end; 

  begin 
    initialise_sortie('CON');
  end. 







