(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)

program essai_analyse_lexicale;
  uses crt,
       utypcons,
       uclavier,
       uediteur, ulexical;
  var g_choix: char;
      g_pt_programme: t_pt_texte;
      g_nom_programme: t_string_80;

  procedure debite_en_symbole(p_ensemble_symboles_finaux: t_ensemble_de_symboles);
    begin
      with g_interprete do
        while not (type_symbole in p_ensemble_symboles_finaux) do
        begin
          lis_symbole(g_pt_programme); write(texte_symbole, '|');
        end; 
      end; 

  procedure analyse_fichier;
    begin
      g_pt_programme^.indice_courant:= 0;
      lis_symbole(g_pt_programme);
      debite_en_symbole([symbole_fin]);
    end; 

  procedure analyse_ligne_clavier;
    begin
      getmem(g_pt_programme, sizeof(t_texte));
      with g_pt_programme^ do
      begin
        nom_texte:= 'CLAVIER';
        texte_max:= 256;
        getmem(pt_tampon_texte, 255);
      end; 
      lis_ligne_clavier(g_pt_programme);
      debite_en_symbole([symbole_QUIT]);
    end; 

  procedure initialise;
    begin 
      g_pt_programme:= nil;
      g_nom_programme:= 'A:EDO.PRG';
    end; 

  begin 
    initialise;
    repeat
      writeln;
      writeln(g_nom_programme);
      write('Nom, Charge, Affiche, Interprete, Klavier, Quitte ? ');
      lis_touche(g_choix); writeln(g_choix);
      case g_choix of
        ' ' : clrscr;
        'c' : charge_texte(g_pt_programme, g_nom_programme, k_texte_max);
        'i' : begin
                if g_pt_programme= nil
                  then charge_texte(g_pt_programme, g_nom_programme, k_texte_max);
                analyse_fichier;
              end;
        'a' : writeln('ajouter diteur ');
        'k' : analyse_ligne_clavier;
        'n' : begin
                write('nom <A:ESSAI.PRG> ? '); readln(g_nom_programme);
              end;
        'r' : affiche_reserves;
      end; 
    until g_choix= 'q';
  end. 
