; 001 iafichier
; 30 jul 91

;--------------------------------------
; librairie: fichiers
;--------------------------------------

                data

k_read_write                 equ    $02
k_dos_ouvre_fichier          equ    $3D
k_dos_lis_fichier            equ    $3F
k_dos_ferme_fichier          equ    $3E

k_dos_cree_fichier           equ    $3C
k_dos_ecris_fichier          equ    $40




                code

int_dos_1       int    $21
                ret



charge_fichier
                ; charge un fichier  l'adresse BX:DX. Le nom est en SI
                ; sauve DX
                push   dx

                ; open file
                mov    ah, k_dos_ouvre_fichier
                mov    al, k_read_write
                mov    dx, si
                xor    cx, cx
                push   ds
                pop    es
                call   int_dos_1
                ; AX contient erreur si CARRY
                ;   le numro du handle sinon

                ; rcupre le dcalage du tampon
                pop    dx
                jnc    .charge_octets

                call   a_la_ligne
                mov    dx, ax
                call   affiche_hex_dx
                call   a_la_ligne
                call   affiche_chaine
                asc    'pb ouverture fichier'
                hex    00
                call   stoppe
                call   clrscr
                jmp_s  .ret

.charge_octets  push   ds
                ; le segment du tampon
                mov    ds, bx
                ; met handle dans BX pour les autres appels
                mov    bx, ax

                ; la quantit maximale
                mov    cx, $FFFF

                ; lis fichier
                mov    ah, k_dos_lis_fichier

                call   int_dos_1
                pop    ds

                jnc    .ferme_fichier

                call   affiche_chaine
                asc    'pb lecture'
                hex    00
                call   stoppe
                jmp    .ret

.ferme_fichier
                ; sauve le nombre d'octets lus
                push   ax

                mov    ah, k_dos_ferme_fichier
                call   int_dos_1
                jnc    .fin

                call   affiche_chaine
                asc    'pb fermeture'
                hex    00
                call   stoppe

.fin            pop    dx

.ret            ret    ; charge_fichier



sauve_fichier   ; sauve CX octets stocks  BX:DX. Nom dans SI
                push   cx
                push   dx

                ; ASSIGN: AH, CX= 0, le nom du fichier dans ES:DX
                mov    ah, k_dos_cree_fichier
                mov    dx, si
                xor    cx, cx
                push   ds
                pop    es
                call   int_dos_1
                ; AX contient erreur si CARRY
                ;   le numro du handle sinon

                pop    dx
                pop    cx
                jnc    .ecris

                call   a_la_ligne
                call   affiche_chaine
                asc    'pb creation fichier'
                hex    00
                call   stoppe
                call   clrscr
                jmp_s  .ret

.ecris          ; DOS: AH= $40, DS:DX: tampon, BX: handle
                push   ds
                ; rcupre le segment du tampon
                mov    ds, bx
                ; handle dans BX pour les autres appels
                mov    bx, ax
                mov    ah, k_dos_ecris_fichier

                call   int_dos_1

                pop    ds

.ferme          ; sauve le nombre d'octets crits
                push   ax

                mov    ah, k_dos_ferme_fichier
                call   int_dos_1
                jnc    .fin

                call   affiche_chaine
                asc    'pb fermeture'
                hex    00
                call   stoppe
.fin
                ; le nombre d'octets effectivement crits
                pop    dx

.ret            ret    ; sauve_fichier



; fin iafichier

