; 001 iasource
; 30 jul 91

;--------------------------------------
; la gestion du texte du source
;--------------------------------------

                data

k_segment_source          equ    $3000
k_decalage_source         equ    $0500

v_nom_source              equ    $0002 ; 12 caractres

v_debut_texte                equ    $0010 ; 2
v_fin_texte                  equ    $0012

k_return                     equ    $0D
k_controle_z                 equ    $1A
k_apostrophe                 equ    $27 ; '



                code

entre_nom_source
                call   a_la_ligne
                call   affiche_chaine
                asc    'nom <gestion.prg> ? '
                hex    00

                ; met un nom dans le tampon pour DOS

                mov    si, v_nom_source
.repeat_nom     call   lis_caractere
                cmp    al, $0D
                je     .fin_nom
                call   affiche_car
                mov    [si], al
                inc    si
                jmp_s  .repeat_nom

.fin_nom        mov    al, $00
                mov    [si], al
                ret    ; entre_nom_source



charge_source
                ; mettre dans BX:DX l'adresse du tampon et adresse du nom dans SI
                mov    bx, k_segment_source
                mov    dx, k_decalage_source
                mov    si, v_nom_source

                call   charge_fichier

                ; rinitialise les variables
                mov    [v_debut_texte], k_decalage_source
                mov    [v_fin_texte], k_decalage_source
                add    [v_fin_texte], dx

                ; affiche nombre octets chargs
                call   affiche_hex_dx

                ; met un zro pour marquer la fin du texte
                mov    si, [v_fin_texte]
                mov    b [si], $00

.ret            ret    ; charge_source



affiche_source
                ; raffiche un source charg
                call   clrscr
                call   initialise_curseur
                mov    si, k_decalage_source
.repete         lods   b
                cmp    al, $00
                je     .fin
                cmp    al, k_return
                jne    .affiche
                call   a_la_ligne
                ; saute interligne
                inc    si
                jmp_s  .repete

.affiche        call   affiche_car
                jmp_s  .repete
.fin
                ret


; fin iasource
