; 001 iavariable
; 30 jul 91

;--------------------------------------
; la gestion des variables
;--------------------------------------

                             data

k_taille_entree_variable     equ    $10 ; 10 caractre, 1 zro, 5 valeur
k_decalage_valeur            equ    $0B

; la taille, 10 caractres du nom, 5 caractres pour la valeur
v_debut_table_variables      equ    $0113 ; 10* (10+ 10)

v_indice_variable_suivante   equ    $010C ; 2 octets
v_indice_variable_courante   equ    $010E ; 2 octets



                code

cherche_variable
                ; retourne v_indice_variable_courante et v_indice_variable_suivante
                ; la variable courante est aussi dans BX
                call   affiche_chaine_test
                asc    'CHERCHE VAR '
                hex    00

                ; sauve l'indice de l'objet
                push   di

                ; DI utilis comme dbut de chaque entre de la table
                mov    di, v_debut_table_variables
                inc    di

                ; sauve indice de la fin du mot
                push   si

                ; SI utilis comme dpart du mot
                mov    si, [v_debut_mot]

.teste_fin      ; ? fin de la table
                cmp    di, [v_indice_variable_suivante]
                jae    .fin

.compare_un_mot ; bx: indice dans le mot
                xor    bx, bx

.compare_une_lettre
                ; la lettre du mot
                mov    al, [bx+ si]

                ; comparee  la lettre de la table
                cmp    al, [bx+ di]
                je     .lettre_suivante

.mot_suivant    ; les lettres sont diffrentes: passe  l'entre suivante
                ; positionne DI au dbut de l'entre suivante
                mov    al, '+'
                call   affiche_car_test

                add    di, k_taille_entree_variable
                jmp_s  .teste_fin

.lettre_suivante
                ; lettres=. Encore une lettre ?

                inc    bx
                cmp    bx, [v_taille_mot]

                ; jmp_s  .compare_une_lettre
                jne    .compare_une_lettre

                dec    di
                mov    al, [di]
                inc    di
                cmp    al, [v_taille_mot]
                jne    .compare_une_lettre

.identiques     ; les deux mots sont bien les mmes
                mov    al, '='
                call   affiche_car_test

.fin            ; retourne la position courante dans la table des variables
                dec    di
                mov    bx, di
                mov    [v_indice_variable_courante], di

                ; rcupre les indice source et objet
                pop    si
                pop    di

                mov    dx, [v_indice_variable_courante]
                call   affiche_hex_dx_test
                mov    dx, [v_indice_variable_suivante]
                call   affiche_hex_dx_test

                ret



alloue_variable
                call   affiche_chaine_test
                asc    ' AJOUTE NELLE VAR '
                hex    00

                ; place la taille et le nom de la variable dans la table
                push   si
                push   di

                mov    si, [v_debut_mot]
                mov    di, [v_indice_variable_suivante]

                ; l'octet de longueur
                mov    al, [v_taille_mot]
                mov    [di], al
                inc    di

                ; le nom
                cld
                ; la taille. Devrait tronquer  10
                mov    cl, [v_taille_mot]
                xor    ch, ch
                repne
                movs   b

                pop    di
                pop    si

                ; la variable suivante sera au-del
                add    w [v_indice_variable_suivante], k_taille_entree_variable

.fin
                ret ; alloue_variable

; fin iavariable
