(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

    const k_ligne= true;
          k_normal= false;

    procedure genere_ligne(p_ligne: boolean);
      begin
        with g_objet, g_sortie do
          if hexa_symbolique and p_ligne
            then begin
                writeln(sortie);
                write(sortie, '$', f_entier_hexadecimal(indice_objet), ': ');
              end;
      end; 

    procedure genere_octet(p_octet: byte; p_ligne: boolean);
      begin
        with g_sortie, g_objet do
          if hexa_symbolique
            then begin
                write(sortie, f_octet_hexadecimal(p_octet));
                indice_objet:= indice_objet+ 1;
              end
            else begin
                tampon_objet[indice_objet]:= p_octet;
                indice_objet:= indice_objet+ 1;
              end;
        genere_ligne(p_ligne);
      end; 

    procedure genere_entier(p_entier: integer; p_ligne: boolean);
      begin
        with g_sortie, g_objet do
          if hexa_symbolique
            then begin
                write(sortie, f_octet_hexadecimal(lo(p_entier)), f_octet_hexadecimal(hi(p_entier)));
                indice_objet:= indice_objet+ 2;
              end
            else begin
                tampon_objet[indice_objet]:= lo(p_entier);
                tampon_objet[indice_objet+ 1]:= hi(p_entier);
                indice_objet:= indice_objet+ 2;
              end;
        genere_ligne(p_ligne);
      end; 

    procedure genere_mot(p_entier: word; p_ligne: boolean);
      begin
        with g_sortie, g_objet do
          if hexa_symbolique
            then begin
                write(sortie, f_octet_hexadecimal(lo(p_entier)), f_octet_hexadecimal(hi(p_entier)));
                indice_objet:= indice_objet+ 2;
              end
            else begin
                tampon_objet[indice_objet]:= lo(p_entier);
                tampon_objet[indice_objet+ 1]:= hi(p_entier);
                indice_objet:= indice_objet+ 2;
              end;
        genere_ligne(p_ligne);
      end; 

    procedure genere_CALL(p_adresse: integer);
      var l_adresse_relative: integer;
      begin
        with g_sortie, g_objet do
        begin
          l_adresse_relative:= p_adresse- $0100- indice_objet- 3;
          if hexa_symbolique
            then begin
                write(sortie, f_octet_hexadecimal(k_code_call));
                write(sortie, f_octet_hexadecimal(lo(l_adresse_relative)),
                    f_octet_hexadecimal(hi(l_adresse_relative)));
                indice_objet:= indice_objet+ 3;
              end
            else begin
                tampon_objet[indice_objet]:= k_code_call;
                tampon_objet[indice_objet+ 1]:= lo(p_adresse- $0100- indice_objet- 3);
                tampon_objet[indice_objet+ 2]:= hi(p_adresse- $0100- indice_objet- 3);
                indice_objet:= indice_objet+ 3;
              end;
        end;
        genere_ligne(k_ligne);
      end; 

    procedure genere_JMP(p_adresse_jmp, p_adresse_label: integer);
      var l_adresse_relative: integer;
      begin
        with g_sortie, g_objet do
        begin
          l_adresse_relative:= p_adresse_label- p_adresse_jmp- 3;
          if hexa_symbolique
            then begin
                write(sortie, 'BACK: ', f_entier_hexadecimal(p_adresse_jmp), ': ',
                      f_octet_hexadecimal(k_code_JMP));
                write(sortie, f_octet_hexadecimal(lo(l_adresse_relative)),
                    f_octet_hexadecimal(hi(l_adresse_relative)));
              end
            else begin
                sonne;
                tampon_objet[p_adresse_jmp]:= k_code_JMP;
                tampon_objet[p_adresse_jmp+ 1]:= lo(l_adresse_relative);
                tampon_objet[p_adresse_jmp+ 2]:= hi(l_adresse_relative);
              end;
        end;
        genere_ligne(k_ligne);
      end; 
