(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)


      function f_chaine_entier(p_chaine: string): integer;
        var l_entier, l_erreur: integer;
        begin
          l_entier:= 0;
          if p_chaine= ''
            then affiche_erreur('chane  convertir vide')
            else begin
                val(p_chaine, l_entier, l_erreur);
                if l_erreur= length(p_chaine)+ 1
                  then l_entier:= 0
                  else
                    if l_erreur<> 0
                      then begin
                          affiche_erreur('conversion numrique >'+ p_chaine+ '<');
                          l_entier:= 0;
                        end
              end;
          f_chaine_entier:= l_entier;
        end; 

      procedure convertis_chaine_espace_en_chaine(var pv_chaine_0;
            p_taille: integer; var pv_chaine: string);
        var l_indice: integer;
        begin
          move(pv_chaine_0, pv_chaine[1], p_taille);
          l_indice:= p_taille;
          while (pv_chaine[l_indice]= ' ') and (l_indice> 1) do
            l_indice:= l_indice- 1;
          pv_chaine[0]:= chr(l_indice);
        end; 

      procedure traite_CREATE;
        var l_pt_fichier_CREATE, l_pt_fichier_donnees: t_pt_fichier_donnees;
            l_masque_CREATE: t_groupe_champs;
            l_tampon_CREATE: t_tampon_balayage;
            l_numero_fiche: longint;
            l_nom_zone, l_chaine_taille, l_chaine_decimales: string;
        begin 
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            if type_symbole= symbole_variable
              then begin
                  cree_fichier_donnees(l_pt_fichier_CREATE, k_chemin_programme+ 'create');
                  ajoute_definition_de_zone(l_pt_fichier_CREATE, 'NOM',       'C', 10, 0);
                  ajoute_definition_de_zone(l_pt_fichier_CREATE, 'TYPE',      'C', 1, 0);
                  ajoute_definition_de_zone(l_pt_fichier_CREATE, 'TAILLE',    'N', 3, 0);
                  ajoute_definition_de_zone(l_pt_fichier_CREATE, 'DECIMALES', 'N', 3, 0);
                  ferme_fichier_donnees(l_pt_fichier_CREATE);
                  ouvre_fichier_donnees(l_pt_fichier_CREATE, k_chemin_programme+ 'create');
                  initialise_balayage_standard(l_pt_fichier_CREATE, l_masque_CREATE,
                      l_tampon_create, 5, 9, 35);
                  balaye_fichier(l_pt_fichier_CREATE, l_masque_CREATE, l_tampon_CREATE,
                      l_pt_fichier_memo);
                  clrscr;
                  positionne_fiche_courante(l_pt_fichier_CREATE, 0);
                  cree_fichier_donnees(l_pt_fichier_donnees, k_chemin_programme+ texte_symbole);
                  for l_numero_fiche:= 1 to f_nombre_fiches(l_pt_fichier_CREATE) do
                  begin
                    lis_fiche_courante(l_pt_fichier_CREATE);
                    convertis_chaine_espace_en_chaine(
                        f_pt_descripteur_zone(l_pt_fichier_create, 0)^.pt_valeur_zone^,
                        10, l_nom_zone);
                    convertis_chaine_espace_en_chaine(
                        f_pt_descripteur_zone(l_pt_fichier_create, 2)^.pt_valeur_zone^,
                        3, l_chaine_taille);
                    convertis_chaine_espace_en_chaine(
                        f_pt_descripteur_zone(l_pt_fichier_create, 3)^.pt_valeur_zone^,
                        3, l_chaine_decimales);
                    ajoute_definition_de_zone(l_pt_fichier_donnees, l_nom_zone,
                      f_pt_descripteur_zone(l_pt_fichier_create, 1)^.pt_valeur_zone^[0],
                      f_chaine_entier(l_chaine_taille),
                      f_chaine_entier(l_chaine_decimales));
                  end; 
                  ferme_fichier_donnees(l_pt_fichier_CREATE);
                  ferme_fichier_donnees(l_pt_fichier_donnees);
                  if teste_interprete
                    then begin
                        ouvre_fichier_donnees(l_pt_fichier_donnees,
                            k_chemin_programme+ texte_symbole);
                        affiche_en_tete_fichier_donnees(l_pt_fichier_donnees);
                        ferme_fichier_donnees(l_pt_fichier_donnees);
                      end;
                end
              else affiche_erreur_programme(p_pt_programme, 'attend nom de fichier sans '' ');
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure affiche_table_fichiers;
        var l_indice_fichier: integer;
        begin
          if wherex<> 1
            then writeln;
          for l_indice_fichier:= 0 to k_fichier_max- 1 do
            with g_interprete, table_fichiers[l_indice_fichier] do
              if nom_fichier<> ''
                then write(l_indice_fichier: 2, nom_fichier, ' ');
          writeln;
        end; 

      procedure supprime_fichier(p_nom_fichier: string);
        var l_indice_variable: integer;
        begin
          with g_interprete do
          begin
            if p_nom_fichier<> ''
              then begin
                  for l_indice_variable:= 1 to indice_variable_max do
                    with table_variables[l_indice_variable] do
                      if proprietaire= p_nom_fichier
                        then privee:= true;
                end;
          end; 
        end; 

      procedure alloue_fichier(p_nom_fichier: string);
        var l_indice_fichier: integer;
            l_libre: boolean;
        begin
          l_libre:= false;
          for l_indice_fichier:= 0 to k_fichier_max- 1 do
            with g_interprete, table_fichiers[l_indice_fichier] do
            begin
              if not l_libre and (nom_fichier= '')
                then begin
                    nom_fichier:= p_nom_fichier;
                    indice_fichier_courant:= l_indice_fichier;
                    l_libre:= true;
                  end;
            end; 
          if not l_libre
            then affiche_erreur_programme(p_pt_programme, 'Trop de fichiers. Ecrase dernier');
        end; 

      function f_fichier_deja_ouvert(p_nom_fichier: string): boolean;
        var l_indice_variable: integer;
            l_deja_ouvert: boolean;
            l_indice_fichier: integer;
        begin
          with g_interprete do
          begin
            l_deja_ouvert:= false;
            for l_indice_variable:= 1 to indice_variable_max do
              with table_variables[l_indice_variable] do
                if proprietaire= p_nom_fichier
                  then begin
                      privee:= false;
                      l_deja_ouvert:= true;
                    end;
            if l_deja_ouvert
              then begin
                  indice_fichier_courant:= -1;
                  repeat
                    indice_fichier_courant:= indice_fichier_courant+ 1;
                  until table_fichiers[indice_fichier_courant].nom_fichier= p_nom_fichier;
                end;
          end; 
          f_fichier_deja_ouvert:= l_deja_ouvert;
        end; 
      (*$v-*)

      procedure traite_USE;
        var l_numero_zone: integer;
            l_pt_descripteur, l_sauve_ancien_descripteur: t_pt_descripteur_de_zone;
            l_nom_fichier: t_nom_proprietaire;
        begin
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            if type_symbole= symbole_variable
              then begin
                  supprime_fichier(table_fichiers[indice_fichier_courant].nom_fichier);
                  if teste_interprete
                    then affiche_table_fichiers;
                  if not f_fichier_deja_ouvert(texte_symbole)
                    then begin
                        alloue_fichier(texte_symbole);
                        with table_fichiers[indice_fichier_courant] do
                        begin
                          if teste_interprete
                            then writeln('ouvre le fichier ', texte_symbole);
                          ouvre_fichier_donnees(pt_fichier_donnees,
                              k_chemin_programme+ texte_symbole);
                          l_nom_fichier:= texte_symbole;
                          for l_numero_zone:= 0 to f_nombre_zones(pt_fichier_donnees)- 1 do
                          begin
                            l_pt_descripteur:=
                                    f_pt_descripteur_zone(pt_fichier_donnees, l_numero_zone);
                            convertis_chaine_db_en_string(l_pt_descripteur^.nom_zone, 10,
                                texte_symbole);
                            if not f_variable_existe
                              then begin
                                  alloue_variable;
                                  with table_variables[indice_variable_courante] do
                                  begin
                                    dispose(pt_descripteur);
                                    pt_descripteur:= l_pt_descripteur;
                                    proprietaire:= l_nom_fichier;
                                    privee:= false;
                                  end; 
                                end
                              else affiche_erreur_programme(p_pt_programme,
                                  'nom '+ texte_symbole+ 'existe dj');
                          end; 
                          initialise_fiche_courante(pt_fichier_donnees);
                        end; 
                      end; 
                  if teste_interprete
                    then affiche_variables;
                  lis_symbole(p_pt_programme);
                end
              else 
                   affiche_erreur_programme(p_pt_programme, 'attend nom du fichier');
          end; 
        end; 

      procedure traite_APPEND;
        begin
          with g_interprete, table_fichiers[indice_fichier_courant] do
          begin
            lis_symbole(p_pt_programme);
            if type_symbole= symbole_BLANK
              then begin
                  positionne_fiche_courante(pt_fichier_donnees,
                      f_nombre_fiches(pt_fichier_donnees));
                  initialise_fiche_courante(pt_fichier_donnees);
                  ecris_fiche_courante(pt_fichier_donnees);
                  lis_symbole(p_pt_programme);
                end
              else affiche_erreur_programme(p_pt_programme, 'attend BLANK');
          end; 
        end; 

      procedure traite_REPLACE;
        var l_indice_a_remplacer: integer;
            l_numero_fiche: longint;

        procedure traite_WITH;
          begin
            with g_interprete, table_fichiers[indice_fichier_courant] do
            begin
              l_numero_fiche:= f_numero_fiche_courante(pt_fichier_donnees)- 1;
              positionne_fiche_courante(pt_fichier_donnees, l_numero_fiche);
              lis_fiche_courante(pt_fichier_donnees);
              move(table_variables[indice_variable_courante].pt_descripteur^.pt_valeur_zone^,
                   table_variables[l_indice_a_remplacer].pt_descripteur^.pt_valeur_zone^,
                   table_variables[l_indice_a_remplacer].pt_descripteur^.taille_zone);
              positionne_fiche_courante(pt_fichier_donnees, l_numero_fiche);
              ecris_fiche_courante(pt_fichier_donnees);
            end; 
          end; 

        begin 
          with g_interprete, table_fichiers[indice_fichier_courant] do
          begin
            lis_symbole(p_pt_programme);
            if type_symbole= symbole_variable
              then begin
                  if f_variable_existe
                    then begin
                        l_indice_a_remplacer:= indice_variable_courante;
                        lis_symbole(p_pt_programme);
                        if type_symbole= symbole_WITH
                          then begin
                              lis_symbole(p_pt_programme);
                              if type_symbole= symbole_variable
                                then begin
                                    if f_variable_existe
                                      then traite_WITH
                                      else affiche_erreur_programme(p_pt_programme,
                                          'attend variable')
                                  end
                                else 
                                    affiche_erreur_programme(p_pt_programme,
                                      'variable '+ texte_symbole+ ' existe pas');
                              lis_symbole(p_pt_programme);
                            end
                          else affiche_erreur_programme(p_pt_programme, 'attend nom variable')
                      end
                    else affiche_erreur_programme(p_pt_programme,
                        'variable '+ texte_symbole+ ' existe pas');
                end
              else affiche_erreur_programme(p_pt_programme, 'attend WITH');
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_CLOSE;
        var l_indice_variable: integer;
            l_indice_fichier: integer;
        begin
          with g_interprete, table_fichiers[indice_fichier_courant] do
          begin
            lis_symbole(p_pt_programme);
            if type_symbole= symbole_DATABASES
              then begin
                  writeln('?? pas implment');
                  readln;
                  ferme_fichier_donnees(pt_fichier_donnees);
                end
              else begin
                  for l_indice_variable:= 1 to indice_variable_max do
                    with table_variables[l_indice_variable] do
                      if proprietaire= texte_symbole
                        then begin
                            table_variables[l_indice_variable].proprietaire[1]:= '*';
                            new(table_variables[l_indice_variable].pt_descripteur);
                          end;
                  for l_indice_fichier:= 0 to k_fichier_max- 1 do
                    with table_fichiers[l_indice_fichier] do
                      if nom_fichier= texte_symbole
                        then begin
                            ferme_fichier_donnees(pt_fichier_donnees);
                            nom_fichier:= '';
                          end;
                end; 
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_LIST;
        var l_numero_zone: integer;
        begin
          with g_interprete, table_fichiers[indice_fichier_courant] do
          begin
            positionne_fiche_courante(pt_fichier_donnees, 0);
            while not f_fin_fichier_donnees(pt_fichier_donnees) do
            begin
              lis_fiche_courante(pt_fichier_donnees);
              for l_numero_zone:= 0 to f_nombre_zones(pt_fichier_donnees)- 1 do
                affiche_zone(pt_fichier_donnees, l_numero_zone);
              writeln;
            end; 
            lis_symbole(p_pt_programme);
          end; 
        end; 
