(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)


      procedure affiche_valeur_variable(p_indice_variable: integer);
        begin
          with g_interprete.table_variables[p_indice_variable].pt_descripteur^, g_sortie do
            case type_zone of
              'N' : write(sortie, valeur_numerique);
              'C', 'L' : affiche_chaine_db(pt_valeur_zone^, taille_zone);
              'D' : 
                    ;
            end; 
        end; 

      procedure affiche_une_variable(p_indice_variable: integer);
        begin
          with g_interprete.table_variables[p_indice_variable], pt_descripteur^, g_sortie do
          begin
            write(sortie, 'PROP ', proprietaire, '--',
                '': k_taille_nom_proprietaire- length(proprietaire),
                nom_zone, '--', '': k_taille_nom_zone_max+ 1- length(nom_zone),
                type_zone);
            if privee
              then write(sortie, ' PRIVEE')
              else write(sortie, '       ');
            write(sortie, ' >');
            affiche_valeur_variable(p_indice_variable);
            writeln(sortie, '<');
          end; 
        end; 

      procedure affiche_variables;
        var l_indice_variable: integer;
        begin
          if wherex<> 1
            then writeln;
          with g_interprete do
            for l_indice_variable:= 1 to indice_variable_max do
              affiche_une_variable(l_indice_variable);
        end; 

      procedure rends_zones_publiques(p_nom_fichier: string);
        var l_indice_variable: integer;
        begin
          with g_interprete do
            for l_indice_variable:= 1 to indice_variable_max do
              with table_variables[l_indice_variable] do
                if proprietaire= p_nom_fichier
                  then privee:= false;
        end; 

      procedure rends_zones_privees(p_nom_fichier: string);
        var l_indice_variable: integer;
        begin
          with g_interprete do
            for l_indice_variable:= 1 to indice_variable_max do
              with table_variables[l_indice_variable] do
                if proprietaire= p_nom_fichier
                  then privee:= true;
        end; 

      function f_variable_existe: boolean;
        var l_nom_fichier: t_nom_proprietaire;

        procedure teste_nom_fichier;
          var l_indice_fichier: integer;
              l_est_nom_fichier: boolean;
          begin
            with g_interprete do
            begin
              l_est_nom_fichier:= false;
              l_indice_fichier:= 0;
              l_nom_fichier:= '';
              while not l_est_nom_fichier and (l_indice_fichier<= k_fichier_max- 1) do
                if table_fichiers[l_indice_fichier].nom_fichier= texte_symbole
                  then l_est_nom_fichier:= true
                  else l_indice_fichier:= l_indice_fichier+ 1;
              if l_est_nom_fichier
                then begin
                    l_nom_fichier:= texte_symbole;
                    lis_symbole(p_pt_programme);
                    if type_symbole= symbole_fleche
                      then begin
                          lis_symbole(p_pt_programme);
                        end
                      else affiche_erreur_programme(p_pt_programme, 'attend ->');
                  end;
            end; 
          end; 

        function f_privee(p_privee: boolean; p_proprietaire: t_nom_proprietaire): boolean;
          begin
            f_privee:= p_privee
              and (p_proprietaire<> p_pt_programme^.nom_texte);
          end; 

        begin 
          with g_interprete do
          begin
            teste_nom_fichier;
            if table_variables[0].pt_descripteur= nil
              then begin
                  write('bug: descripteur NIL'); readln;
                end;
            with table_variables[0], pt_descripteur^ do
            begin
              fillchar(table_variables[0].proprietaire, sizeof(proprietaire), 0);
              fillchar(table_variables[0].pt_descripteur^,
                     sizeof(t_descripteur_de_zone), 0);
              if texte_symbole<> ''
                then move(texte_symbole[1], nom_zone, length(texte_symbole));
              type_zone:= '?';
              proprietaire:= p_pt_programme^.nom_texte;
              privee:= false;
            end; 
            if l_nom_fichier<> ''
              then begin
                  rends_zones_privees(table_fichiers[indice_fichier_courant].nom_fichier);
                  rends_zones_publiques(l_nom_fichier);
                end;
            indice_variable_courante:= indice_variable_max;
            indice_variable_libre:= indice_variable_max+ 1;
            while not f_egal(table_variables[indice_variable_courante].pt_descripteur^.nom_zone,
                               table_variables[0].pt_descripteur^.nom_zone,
                               k_taille_nom_zone_max)
               or f_privee(table_variables[indice_variable_courante].privee,
                                table_variables[indice_variable_courante].proprietaire) do
            begin
              if table_variables[indice_variable_courante].proprietaire[1]= '*'
                then indice_variable_libre:= indice_variable_courante;
              indice_variable_courante:= indice_variable_courante- 1;
            end;
            f_variable_existe:= indice_variable_courante> 0;
            if indice_variable_courante= 0
              then indice_variable_courante:= - 1;
            if l_nom_fichier<> ''
              then begin
                  rends_zones_privees(l_nom_fichier);
                  rends_zones_publiques(table_fichiers[indice_fichier_courant].nom_fichier);
                end;
          end; 
        end; 

      procedure alloue_variable;
        begin
          with g_interprete do
          begin
            if indice_variable_libre= indice_variable_max+ 1
              then begin
                  indice_variable_courante:= indice_variable_max+ 1;
                  indice_variable_max:= indice_variable_max+ 1;
                end
              else indice_variable_courante:= indice_variable_libre;
            if table_variables[indice_variable_courante].pt_descripteur= nil
              then begin
                  write('bug: pt_descripteur NIL');
                  readln;
                end;
            with table_variables[indice_variable_courante] do
            begin
              move(table_variables[0], table_variables[indice_variable_courante],
                sizeof(proprietaire));
              move(table_variables[0].pt_descripteur^, pt_descripteur^,
                sizeof(t_descripteur_de_zone));
            end; 
          end; 
        end; 

      procedure stocke_valeur_chaine(var pv_chaine_0; p_taille: integer);
        var l_pt_valeur: t_pt_valeur_zone;
        begin
          with g_interprete do
          begin
            if indice_valeur_variable_suivante+ p_taille<= k_tampon_valeur_variable_max
              then begin
                  with table_variables[indice_variable_courante].pt_descripteur^ do
                  begin
                    pt_valeur_zone:=
                        addr(tampon_valeur_variable[indice_valeur_variable_suivante]);
                    taille_zone:= p_taille;
                    if p_taille> 0
                      then move(pv_chaine_0, pt_valeur_zone^, p_taille);
                  end; 
                  indice_valeur_variable_suivante:= indice_valeur_variable_suivante
                    + p_taille;
                end
              else
                affiche_erreur('plus de place valeurs variables');
          end; 
        end; 
