(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+,v-*)

program fichier_de_donnees;
  uses crt;
  type t_string_80= string[80];
       t_string_255= string[255];
  (*$i a:isortie *)
  var g_choix: char;
      g_nom_donnees: t_string_80;

  procedure affiche_chaine_0(var pv_chaine_0; var pv_taille: integer);
    var l_chaine_surtypee: array[0..255] of char absolute pv_chaine_0;
        l_indice_chaine: integer;
    begin
      l_indice_chaine:= 0;
      while l_chaine_surtypee[l_indice_chaine]<> chr(0) do
      begin
        write(g_sortie, l_chaine_surtypee[l_indice_chaine]);
        l_indice_chaine:= l_indice_chaine+ 1;
      end;
      pv_taille:= l_indice_chaine;
    end; 

  procedure affiche_fichier_donnees;
    const k_taille_descripteur_zone= 32;
          k_descripteur_zone_max= 127;
          k_taille_en_tete_max= 4130;
          k_taille_nom_zone_max= 10;
    type t_nom_zone= array[0..k_taille_nom_zone_max] of char;
         t_descripteur_de_zone= record
                                  nom_zone: t_nom_zone;
                                  type_zone: char;
                                  adresse_memoire: longint;
                                  taille_zone: byte;
                                  nombre_decimales: byte;
                                  remplissage: array[18..31] of byte;
                                end;
         t_en_tete_donnees= record
                              signature: byte;
                              date_derniere_mise_a_jour: array[0..2] of byte;
                              nombre_fiches: longint;
                              taille_en_tete: word;
                              taille_fiche: word;
                              remplissage: array[12..31] of byte;
                              tableau_description_zones: array[0..k_descripteur_zone_max]
                                of t_descripteur_de_zone;
                            end;
    var l_donnees: file;
        l_en_tete: t_en_tete_donnees;
        l_taille: word;

    procedure affiche_les_descripteurs_de_zone;
      var l_numero_zone, l_taille: integer;
      begin
        with l_en_tete do
        begin
          writeln(g_sortie, 'numero   nom      type taille decimales');
          l_numero_zone:= 0;
          while tableau_description_zones[l_numero_zone].nom_zone[0]<> chr($0D) do
          begin
            write(g_sortie, l_numero_zone: 4, '':3);
            with tableau_description_zones[l_numero_zone] do
            begin
              affiche_chaine_0(nom_zone, l_taille);
              writeln(g_sortie, '': k_taille_nom_zone_max- l_taille,
                     type_zone: 5, taille_zone: 6, nombre_decimales: 8);
            end; 
            l_numero_zone:= l_numero_zone+ 1;
          end; 
        end; 
      end; 

    begin 
      assign(l_donnees, g_nom_donnees+ '.DBF');
      reset(l_donnees, 1);
      l_taille:= filesize(l_donnees);
      if l_taille> sizeof(l_en_tete)
        then l_taille:= sizeof(l_en_tete);
      blockread(l_donnees, l_en_tete, l_taille);
      with l_en_tete do
      begin
        writeln(g_sortie, 'signature:        ', signature);
        writeln(g_sortie, 'dernire anne:   ', 1900+ date_derniere_mise_a_jour[0]);
        writeln(g_sortie, 'dernier mois:     ', date_derniere_mise_a_jour[1]);
        writeln(g_sortie, 'dernier jour:     ', date_derniere_mise_a_jour[2]);
        writeln(g_sortie, 'nombre de fiches: ', nombre_fiches);
        writeln(g_sortie, 'taille en-tte:   ', taille_en_tete);
        writeln(g_sortie, 'taille fiche:     ', taille_fiche);
        affiche_les_descripteurs_de_zone;
      end; 
      close(l_donnees);
    end; 

  procedure entre_nom_fichier;
    begin
      write(g_sortie, 'nom fichier <CLIENT> ?'); readln(g_nom_donnees);
    end; 

  procedure initialise;
    begin
      g_nom_donnees:= 'A:CLIENTS';
      initialise_sortie;
    end; 

  begin 
    initialise;
    repeat
      writeln;
      writeln(g_nom_donnees, ' -> ', g_nom_sortie);
      write('Nom, Affiche, Sortie, Quitte ? ');
      g_choix:= upcase(readkey); writeln(g_choix);
      case g_choix of
        'A' : affiche_fichier_donnees;
        'N' : entre_nom_fichier;
        'S' : choisis_sortie;
      end;
    until g_choix= 'Q';
    ferme_sortie;
  end. 
