(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)

program gestion_variable_avec_un_index;
  uses crt,
       uclavier, uerreur,
       utypcons,
       uecran, usortie, uaffiche, usaisis,
       udonnees, uchamps, usaisfic, uexgest,
       uchained,
       uindex, uexindex;
  type t_numero_fiche= longint;
  var g_choix: char;

  procedure ajoute_la_cle;
    var l_chaine_cle: string;
        l_cle_db: t_cle_db;
    begin
      ouvre_index(g_index, g_nom_index);
      writeln('attention: ne mettra pas le numro de fiche correct'); readln;
      write('cl  ajouter <ZZZZ> ? '); readln(l_chaine_cle);
      move(l_chaine_cle[1], l_cle_db, sizeof(l_cle_db));
      ajoute_cle(g_index, l_cle_db, -999);
      ferme_index(g_index);
    end; 

  procedure cherche_la_cle;
    var l_chaine_cle: string;
        l_cle_db: t_cle_db;
        l_numero: longint;
        l_a_trouve: boolean;
    begin
      ouvre_index(g_index, g_nom_index);
      write('cl cherche <ZZZZ> ? '); readln(l_chaine_cle);
      move(l_chaine_cle[1], l_cle_db, sizeof(l_cle_db));
      cherche_cle(g_index, l_cle_db, l_numero, l_a_trouve);
      writeln(l_numero, ' ', l_a_trouve);
      ferme_index(g_index);
    end; 

  procedure cherche_la_suivante;
    var l_chaine_cle: string;
        l_cle_db: t_cle_db;
        l_numero: t_numero_fiche;
        l_a_trouve: boolean;
    begin
      ouvre_index(g_index, g_nom_index);
      cherche_cle_suivante(g_index, l_numero);
      writeln(l_numero);
      ferme_index(g_index);
    end; 

  procedure cherche_la_precedante;
    var l_chaine_cle: string;
        l_cle_db: t_cle_db;
        l_numero: t_numero_fiche;
        l_a_trouve: boolean;
    begin
      ouvre_index(g_index, g_nom_index);
      cherche_cle_precedante(g_index, l_numero);
      writeln(l_numero);
      ferme_index(g_index);
    end; 

  procedure efface_la_cle;
    var l_chaine_cle: string;
        l_cle_db: t_cle_db;
    begin
      ouvre_index(g_index, g_nom_index);
      write('cl  effacer ? '); readln(l_chaine_cle);
      move(l_chaine_cle[1], l_cle_db, sizeof(l_cle_db));
      efface_cle(g_index, l_cle_db);
      ferme_index(g_index);
    end; 
  (*$i a:itestei *)

  procedure initialise;
    begin 
      g_nom_fichier:= 'A:CLIENTS';
      g_nom_index:= g_nom_fichier+ '.NDX';
    end; 

  begin 
    initialise;
    repeat
      writeln;
      writeln(g_nom_fichier, '(', g_nom_index, ') -> ', g_sortie.nom_sortie);
      writeln('fichier: Cree, Gnre, Liste, liste indeXe');
      write('index: cRe, cOnstruis, lIste, liste Pages, Efface, cHerche, Test ');
      write('Quitte ? ');
      lis_touche(g_choix); writeln(g_choix);
      case g_choix of
        ' ' : clrscr;
        'c' : cree_DBF;
        'g' : genere_DBF(20);
        'l' : liste_DBF;
        'r' : cree_un_index(4);
        'o' : construis_index(4);
        'x' : liste_indexee;
        'j' : ajoute_la_cle;
        'h' : cherche_la_cle;
        '+' : cherche_la_precedante;
        '-' : efface_la_cle;
        'e' : efface_la_cle;
        'd' : begin
                ouvre_index(g_index, g_nom_index);
                affiche_descripteur_index(g_index);
                ferme_index(g_index);
              end;
        'p' : begin
                ouvre_index(g_index, g_nom_index);
                liste_pages_index(g_index);
                ferme_index(g_index);
              end;
        'i' : begin
                ouvre_index(g_index, g_nom_index);
                liste_index(g_index);
                ferme_index(g_index);
              end;
        't' : teste_ajout_effacement;
      end;
    until g_choix= 'q';
  end. 
