(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)

program gestion_variable_balayage_dans_l_ordre;
  uses dos, crt,
       uclavier, uerreur,
       utypcons,
       uecran, uaffiche, usortie, usaisis,
       udonnees, uchamps, usaisfic, uexgest,
       uindex, uexindex,
       ubalayei;
  var g_choix: char;

  procedure balaye_sequentiellement;
    var l_masque: t_groupe_champs;
        l_tampon: t_tampon_balayage;
    begin 
      ouvre_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
      initialise_balayage_standard(g_pt_fichier_donnees, l_masque, l_tampon, 5, 9, 35);
      balaye_fichier(g_pt_fichier_donnees, l_masque, l_tampon, g_index, balayage_sequentiel);
      libere_groupe_de_champs(l_masque);
      ferme_fichier_donnees(g_pt_fichier_donnees);
    end; 

  procedure balaye_dans_l_ordre;
    var l_masque: t_groupe_champs;
        l_tampon: t_tampon_balayage;
    begin 
      ouvre_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
      initialise_balayage_standard(g_pt_fichier_donnees, l_masque, l_tampon,
          5, 9, 70);
      ouvre_index(g_index, g_nom_index);
      balaye_fichier(g_pt_fichier_donnees, l_masque, l_tampon, g_index, balayage_indexe);
      libere_groupe_de_champs(l_masque);
      ferme_fichier_donnees(g_pt_fichier_donnees);
      ferme_index(g_index);
    end; 

  procedure initialise;
    begin 
      g_nom_fichier:= 'A:CLIENTS.DBF';
      g_nom_index:= 'A:CLIENTS.NDX';
    end; 

  begin 
    initialise;
    repeat
      writeln;
      writeln(g_nom_fichier, ' (', g_nom_index, ') -> ', g_sortie.nom_sortie, ' ', memavail);
      writeln('Cree, Gnre, Liste, Balaye dans l''ordre');
      write('index: cRe, cOnstruis, lIste, balaYe index, ');
      write('Quitte ? ');
      lis_touche(g_choix); writeln(g_choix);
      case g_choix of
        ' ' : clrscr;
        'a' : affiche_descripteur_DBF;
        'c' : cree_DBF;
        'g' : genere_DBF(9);
        'l' : liste_DBF;
        'x' : liste_indexee;
        'r' : cree_un_index(4);
        'o' : construis_index(4);
        'p' : begin
                ouvre_index(g_index, g_nom_index);
                liste_pages_index(g_index);
                ferme_index(g_index);
              end;
        'i' : begin
                ouvre_index(g_index, g_nom_index);
                liste_index(g_index);
                ferme_index(g_index);
              end;
        'y' : balaye_dans_l_ordre;
        'b' : balaye_sequentiellement;
      end;
    until g_choix= 'q';
  end. 
