(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)


  procedure efface_cle(var pv_index: t_index; p_cle_db: t_cle_db);
    const k_hauteur_pile_max= 100;
    type t_pile= record
                   numero_page_mere: t_numero_page;
                   indice_mere: integer;
                 end;
    var l_page: t_page;
        l_doit_consolider: boolean;

    procedure consolide(p_numero_mere, p_numero_page_a_consolider: t_numero_page;
                       p_indice_mere: integer);
      var l_nombre_cles_mere: integer;
          l_page_mere: t_page;

      procedure consolide_avec_page_de_droite;
        var l_numero_page_droite: t_numero_page;
            l_page_droite: t_page;
            l_nombre_disponibles, l_nombre_droite: integer;
            l_pt_page, l_pt_page_mere, l_pt_page_droite: t_pt_cellule;
            l_pt_fille, l_pt_fille_mere, l_pt_fille_droite: t_pt_fille;

        procedure consolide_feuille;

          procedure partage_entre_feuille_et_feuille_droite;
            begin
              with pv_index do
              begin
                if l_nombre_disponibles>= 1
                  then begin
                      move(l_page_droite.tableau_positions,
                            l_page.tableau_positions[(moitie_nombre_cles_max- 1)* taille_cellule],
                            (l_nombre_disponibles- 1+ 1)* taille_cellule);
                    end;
                move(l_page_droite.tableau_positions[(l_nombre_disponibles- 1)* taille_cellule+ 4],
                     l_page_mere.tableau_positions[(p_indice_mere- 1)* taille_cellule+ 4],
                     taille_cle);
                with f_pt_cellule(pv_index, l_page_droite, l_nombre_disponibles,
                    l_pt_fille_droite)^ do
                  l_page_droite.numero_page_0:= l_pt_fille_droite^;
                l_nombre_droite:= l_nombre_droite- l_nombre_disponibles;
                move(l_page_droite.tableau_positions[(l_nombre_disponibles)* taille_cellule],
                     l_page_droite.tableau_positions[0],
                     (l_nombre_droite)* taille_cellule);
                l_page_droite.nombre_cellules_utilisees:= l_nombre_droite;
                l_page.nombre_cellules_utilisees:=
                  moitie_nombre_cles_max- 1+ l_nombre_disponibles;
                l_doit_consolider:= false;
              end; 
            end; 

          procedure fusionne_feuille_et_feuille_droite;
            begin
              with pv_index do
              begin
                move(l_page_droite.tableau_positions[0],
                    l_page.tableau_positions[(moitie_nombre_cles_max- 1)* taille_cellule],
                    moitie_nombre_cles_max* taille_cellule);
                if p_indice_mere< l_nombre_cles_mere
                  then move(l_page_mere.tableau_positions[(p_indice_mere)* taille_cellule],
                            l_page_mere.tableau_positions[(p_indice_mere- 1)* taille_cellule],
                            (l_nombre_cles_mere- p_indice_mere)* taille_cellule);
                l_page.nombre_cellules_utilisees:= nombre_cles_max- 1;
                l_page_mere.nombre_cellules_utilisees:= l_nombre_cles_mere- 1;
                l_doit_consolider:= l_page_mere.nombre_cellules_utilisees< moitie_nombre_cles_max;
              end; 
            end; 

          begin 
            with pv_index do
            begin
              if l_nombre_disponibles> 0
                then partage_entre_feuille_et_feuille_droite
                else begin
                    fusionne_feuille_et_feuille_droite;
                    l_page_droite.nombre_cellules_utilisees:= 0;
                  end;
            end; 
          end; 

        procedure consolide_noeud;

          procedure partage_entre_noeud_et_noeud_droite;
            begin
              with pv_index do
              begin
                if l_nombre_disponibles> 1
                  then move(l_page_droite.tableau_positions,
                            l_page.tableau_positions[(moitie_nombre_cles_max)* taille_cellule],
                            (l_nombre_disponibles- 1)* taille_cellule);
                move(l_page_droite.tableau_positions[(l_nombre_disponibles- 1)* taille_cellule+ 4],
                     l_page_mere.tableau_positions[(p_indice_mere- 1)* taille_cellule+ 4],
                     taille_cle);
                with f_pt_cellule(pv_index, l_page_droite, l_nombre_disponibles,
                    l_pt_fille_droite)^ do
                  l_page_droite.numero_page_0:= l_pt_fille_droite^;
                l_nombre_droite:= l_nombre_droite- l_nombre_disponibles;
                move(l_page_droite.tableau_positions[(l_nombre_disponibles)* taille_cellule],
                     l_page_droite.tableau_positions[0],
                     (l_nombre_droite)* taille_cellule);
                l_page_droite.nombre_cellules_utilisees:= l_nombre_droite;
                l_page.nombre_cellules_utilisees:=
                  moitie_nombre_cles_max- 1+ l_nombre_disponibles;
                l_doit_consolider:= false;
              end; 
            end; 

          procedure fusionne_noeud_et_noeud_droite;
            begin
              with pv_index do
              begin
                move(l_page_droite.tableau_positions[0],
                    l_page.tableau_positions[(moitie_nombre_cles_max)* taille_cellule],
                    moitie_nombre_cles_max* taille_cellule);
                if p_indice_mere< l_nombre_cles_mere
                  then move(l_page_mere.tableau_positions[(p_indice_mere)* taille_cellule],
                            l_page_mere.tableau_positions[(p_indice_mere- 1)* taille_cellule],
                            (l_nombre_cles_mere- p_indice_mere)* taille_cellule);
                l_page.nombre_cellules_utilisees:= nombre_cles_max;
                l_page_mere.nombre_cellules_utilisees:= l_nombre_cles_mere- 1;
                l_doit_consolider:= l_page_mere.nombre_cellules_utilisees< moitie_nombre_cles_max;
              end; 
            end; 

          begin 
            with pv_index do
            begin
              l_page.tableau_positions[(moitie_nombre_cles_max- 1)* taille_cellule]:=
                l_page_mere.tableau_positions[(p_indice_mere- 1)* taille_cellule];
              with f_pt_cellule(pv_index, l_page, moitie_nombre_cles_max, l_pt_fille)^ do
                l_pt_fille^:= l_page_droite.numero_page_0;
              if l_nombre_disponibles> 0
                then partage_entre_noeud_et_noeud_droite
                else begin
                    fusionne_noeud_et_noeud_droite;
                    l_page_droite.nombre_cellules_utilisees:= 0;
                  end;
            end; 
          end; 

        begin 
          with pv_index do
          begin
            p_indice_mere:= p_indice_mere + 1;
            with f_pt_cellule(pv_index, l_page_mere, p_indice_mere, l_pt_fille_mere)^ do
              l_numero_page_droite:= l_pt_fille_mere^;
            seek(fichier_b_arbre, l_numero_page_droite);
            blockread(fichier_b_arbre, l_page_droite, 1);
            l_nombre_droite:= l_page_droite.nombre_cellules_utilisees;
            l_nombre_disponibles:= (l_nombre_droite- moitie_nombre_cles_max+ 1) div 2;
            if l_page.numero_page_0= k_nil
              then consolide_feuille
              else consolide_noeud;
            seek(fichier_b_arbre, l_numero_page_droite);
            blockwrite(fichier_b_arbre, l_page_droite, 1);
          end; 
        end; 

      procedure consolide_avec_page_de_gauche;
        var l_numero_page_gauche: t_numero_page;
            l_page_gauche: t_page;
            l_nombre_disponibles, l_nombre_gauche: integer;
            l_pt_cellule_mere: t_pt_cellule;
            l_pt_fille_mere: t_pt_fille;

        procedure partage_entre_page_gauche_et_page;
          var l_pt_cellule_mere, l_pt_cellule_droite, l_pt_cellule_gauche: t_pt_cellule;
              l_pt_fille_mere, l_pt_fille_droite, l_pt_fille_gauche: t_pt_fille;

          procedure partage_feuilles;
            begin
              with pv_index do
              begin
                move(l_page.tableau_positions[0],
                       l_page.tableau_positions[l_nombre_disponibles* taille_cellule],
                       (moitie_nombre_cles_max- 1)* taille_cellule);
                l_nombre_gauche:= l_nombre_gauche- l_nombre_disponibles;
                if l_nombre_disponibles>= 1
                  then begin
                      move(l_page_gauche.tableau_positions[(l_nombre_gauche- 1)* taille_cellule],
                            l_page.tableau_positions,
                            (l_nombre_disponibles)* taille_cellule);
                    end;
                l_pt_cellule_gauche:= f_pt_cellule(pv_index, l_page_gauche, l_nombre_gauche- 1,
                    l_pt_fille_gauche);
                l_pt_cellule_mere:= f_pt_cellule(pv_index, l_page_mere, p_indice_mere, l_pt_fille_mere);
                move(l_pt_cellule_gauche^.cle_db, l_pt_cellule_mere^.cle_db, taille_cle);
                l_page_gauche.nombre_cellules_utilisees:= l_nombre_gauche- 1;
                l_page.nombre_cellules_utilisees:= moitie_nombre_cles_max- 1+ l_nombre_disponibles;
              end; 
            end; 

          procedure partage_noeuds;
            begin
              with pv_index do
              begin
                move(l_page.tableau_positions[0],
                       l_page.tableau_positions[l_nombre_disponibles* taille_cellule],
                       (moitie_nombre_cles_max- 1)* taille_cellule);
                l_pt_cellule_mere:= f_pt_cellule(pv_index, l_page_mere, p_indice_mere, l_pt_fille_mere);
                l_pt_cellule_droite:= f_pt_cellule(pv_index, l_page, l_nombre_disponibles,
                    l_pt_fille_droite);
                move(l_pt_cellule_mere^, l_pt_cellule_droite^, taille_cellule);
                l_pt_fille_droite^:= l_page.numero_page_0;
                l_nombre_gauche:= l_nombre_gauche- l_nombre_disponibles;
                if l_nombre_disponibles> 1
                  then move(l_page_gauche.tableau_positions[l_nombre_gauche* taille_cellule],
                            l_page.tableau_positions,
                            (l_nombre_disponibles- 1)* taille_cellule);
                l_pt_cellule_gauche:= f_pt_cellule(pv_index, l_page_gauche, l_nombre_gauche,
                    l_pt_fille_gauche);
                l_page.numero_page_0:= l_pt_fille_gauche^;
                if l_page_gauche.numero_page_0= k_nil
                  then begin
                      l_pt_cellule_gauche:= f_pt_cellule(pv_index, l_page_gauche,
                          l_nombre_gauche- 1, l_pt_fille_gauche);
                      move(l_pt_cellule_gauche^.cle_db, l_pt_cellule_mere^.cle_db, taille_cle);
                    end
                  else move(l_pt_cellule_gauche^.cle_db, l_pt_cellule_mere^.cle_db, taille_cle);
                l_page_gauche.nombre_cellules_utilisees:= l_nombre_gauche- 1;
                l_page.nombre_cellules_utilisees:=
                   moitie_nombre_cles_max- 1+ l_nombre_disponibles;
              end; 
            end; 

          begin 
            with pv_index do
            begin
              if l_page.numero_page_0= k_nil
                then partage_feuilles
                else partage_noeuds;
              l_doit_consolider:= false;
            end; 
          end; 

        procedure fusionne_page_gauche_et_page;
          var l_pt_cellule_mere, l_pt_cellule_gauche: t_pt_cellule;
              l_pt_fille_mere, l_pt_fille_gauche: t_pt_fille;

          procedure fusionne_feuille_gauche_et_feuille;
            begin
              with pv_index do
              begin
                move(l_page.tableau_positions[0],
                       l_page_gauche.tableau_positions[(l_nombre_gauche- 1)* taille_cellule],
                       (moitie_nombre_cles_max- 1)* taille_cellule);
                l_page_gauche.nombre_cellules_utilisees:= nombre_cles_max- 1;
                l_page_mere.nombre_cellules_utilisees:= l_nombre_cles_mere- 1;
                l_doit_consolider:= l_page_mere.nombre_cellules_utilisees< moitie_nombre_cles_max;
              end; 
            end; 

          procedure fusionne_noeud_gauche_et_noeud;
            begin
              with pv_index do
              begin
                l_pt_cellule_mere:= f_pt_cellule(pv_index, l_page_mere, p_indice_mere, l_pt_fille_mere);
                l_pt_cellule_gauche:= f_pt_cellule(pv_index, l_page_gauche, l_nombre_gauche,
                    l_pt_fille_gauche);
                move(l_pt_cellule_mere^, l_pt_cellule_gauche^, taille_cellule);
                l_pt_fille_gauche^:= l_pt_fille_mere^;
                if moitie_nombre_cles_max> 1
                  then move(l_page.tableau_positions[0],
                              l_page_gauche.tableau_positions[l_nombre_gauche* taille_cle],
                              (moitie_nombre_cles_max- 1)* taille_cle);
                l_page_gauche.nombre_cellules_utilisees:= nombre_cles_max;
                l_page_mere.nombre_cellules_utilisees:= l_nombre_cles_mere- 1;
                l_doit_consolider:= l_page_mere.nombre_cellules_utilisees< moitie_nombre_cles_max;
              end; 
            end; 

          begin 
            with pv_index do
            begin
              if l_page_gauche.numero_page_0= k_nil
                then fusionne_feuille_gauche_et_feuille
                else fusionne_noeud_gauche_et_noeud;
            end; 
          end; 

        begin 
          with pv_index do
          begin
            if p_indice_mere= 1
              then l_numero_page_gauche:= l_page_mere.numero_page_0
              else begin
                  l_pt_cellule_mere:= f_pt_cellule(pv_index, l_page_mere, p_indice_mere- 1,
                      l_pt_fille_mere);
                  l_numero_page_gauche:= l_pt_fille_mere^;
                end;
            seek(fichier_b_arbre, l_numero_page_gauche);
            blockread(fichier_b_arbre, l_page_gauche, 1);
            l_nombre_gauche:= l_page_gauche.nombre_cellules_utilisees + 1;
            l_nombre_disponibles:= (l_nombre_gauche- moitie_nombre_cles_max) div 2;
            if l_nombre_disponibles> 0
              then partage_entre_page_gauche_et_page
              else begin
                  fusionne_page_gauche_et_page;
                  l_page.nombre_cellules_utilisees:= 0;
                end;
            seek(fichier_b_arbre, l_numero_page_gauche);
            blockwrite(fichier_b_arbre, l_page_gauche, 1);
          end; 
        end; 

      begin 
        with pv_index do
        begin
          seek(fichier_b_arbre, p_numero_page_a_consolider);
          blockread(fichier_b_arbre, l_page, 1);
          seek(fichier_b_arbre, p_numero_mere);
          blockread(fichier_b_arbre, l_page_mere, 1);
          l_nombre_cles_mere:= l_page_mere.nombre_cellules_utilisees;
          if p_indice_mere< l_nombre_cles_mere
            then consolide_avec_page_de_droite
            else consolide_avec_page_de_gauche;
          seek(fichier_b_arbre, p_numero_mere);
          blockwrite(fichier_b_arbre, l_page_mere, 1);
          seek(fichier_b_arbre, p_numero_page_a_consolider);
          blockwrite(fichier_b_arbre, l_page, 1);
        end; 
      end; 
    var l_pt_fille: t_pt_fille;
        l_numero_page: t_numero_page;
        l_indice_superieur, l_indice_inferieur, l_indice_milieu: integer;
        l_a_trouve: boolean;
        l_pile: array[0..k_hauteur_pile_max] of t_pile;
        l_sommet_pile: integer;

    procedure remplace_cle_du_milieu;
      var l_numero_page_remplacant: t_numero_page;
          l_page_remplacant: t_page;
          l_pt_fille_1: t_pt_fille;
      begin
        with pv_index do
        begin
          l_pile[l_sommet_pile].numero_page_mere:= l_numero_page;
          l_pile[l_sommet_pile].indice_mere:= l_indice_inferieur;
          l_sommet_pile:= l_sommet_pile+ 1;
          if l_indice_milieu= 1
            then l_numero_page_remplacant:= l_page.numero_page_0
            else
              with f_pt_cellule(pv_index, l_page, l_indice_milieu- 1, l_pt_fille_1)^ do
                l_numero_page_remplacant:= l_pt_fille_1^;
          repeat
            seek(fichier_b_arbre, l_numero_page_remplacant);
            blockread(fichier_b_arbre, l_page_remplacant, 1);
            if l_page_remplacant.numero_page_0<> k_nil
              then begin
                  l_pile[l_sommet_pile].numero_page_mere:= l_numero_page_remplacant;
                  l_pile[l_sommet_pile].indice_mere:= l_page_remplacant.nombre_cellules_utilisees;
                  l_sommet_pile:= l_sommet_pile+ 1;
                  with l_page_remplacant do
                    with f_pt_cellule(pv_index, l_page_remplacant, nombre_cellules_utilisees,
                        l_pt_fille_1)^ do
                      l_numero_page_remplacant:= l_pt_fille^;
                end;
          until l_page_remplacant.numero_page_0= k_nil;
          with l_page_remplacant do
          begin
            move(tableau_positions[(nombre_cellules_utilisees- 2)* taille_cellule+ 4],
                   l_page.tableau_positions[l_indice_inferieur* taille_cellule+ 4],
                   taille_cle);
          end; 
          seek(fichier_b_arbre, l_numero_page);
          blockwrite(fichier_b_arbre, l_page, 1);
          l_numero_page:= l_numero_page_remplacant;
          l_page:= l_page_remplacant;
          l_indice_inferieur:= l_page.nombre_cellules_utilisees- 1;
        end; 
      end; 

    begin 
      with pv_index do
      begin
        l_numero_page:= numero_racine;
        l_sommet_pile:= 0;
        l_a_trouve:= false;
        if l_numero_page<> k_nil
          then
            repeat
              seek(fichier_b_arbre, l_numero_page);
              blockread(fichier_b_arbre, l_page, 1);
              with l_page do
              begin
                l_indice_superieur:= 1;
                l_indice_inferieur:= nombre_cellules_utilisees;
                repeat
                  l_indice_milieu:= (l_indice_superieur+ l_indice_inferieur) div 2;
                  with f_pt_cellule(pv_index, l_page, l_indice_milieu, l_pt_fille)^ do
                  begin
                    if f_inferieur_ou_egal(p_cle_db, cle_db, taille_cle)
                      then l_indice_inferieur:= l_indice_milieu- 1;
                    if f_inferieur_ou_egal(cle_db, p_cle_db, taille_cle)
                      then l_indice_superieur:= l_indice_milieu+ 1;
                  end; 
                until l_indice_inferieur< l_indice_superieur;
                if l_indice_superieur- l_indice_inferieur> 1
                  then 
                       l_a_trouve:= true
                  else begin
                      l_pile[l_sommet_pile].numero_page_mere:= l_numero_page;
                      l_pile[l_sommet_pile].indice_mere:= l_indice_inferieur;
                      l_sommet_pile:= l_sommet_pile+ 1;
                      if l_indice_inferieur= 0
                        then l_numero_page:= numero_page_0
                        else begin
                            with f_pt_cellule(pv_index, l_page, l_indice_inferieur, l_pt_fille)^ do
                                l_numero_page:= l_pt_fille^;
                          end;
                    end; 
              end; 
            until l_a_trouve or (l_page.numero_page_0= k_nil);
        if not l_a_trouve
          then begin
              affiche_erreur('pas trouv la cl '+ p_cle_db);
              exit;
            end;
        if l_page.numero_page_0<> k_nil
          then begin
              remplace_cle_du_milieu;
            end;
        with l_page do
        begin
          nombre_cellules_utilisees:= nombre_cellules_utilisees- 1;
          if l_indice_inferieur< nombre_cellules_utilisees
            then move(tableau_positions[(l_indice_inferieur+ 1)* taille_cellule],
                      tableau_positions[(l_indice_inferieur+ 0)* taille_cellule],
                      (nombre_cellules_utilisees- l_indice_inferieur)* taille_cellule);
          seek(fichier_b_arbre, l_numero_page);
          blockwrite(fichier_b_arbre, l_page, 1);
          l_doit_consolider:= nombre_cellules_utilisees< moitie_nombre_cles_max;
        end;
        while l_doit_consolider do
        begin
          l_sommet_pile:= l_sommet_pile- 1;
          if l_sommet_pile= -1
            then begin
                seek(fichier_b_arbre, numero_racine);
                blockread(fichier_b_arbre, l_page, 1);
                if l_page.nombre_cellules_utilisees= 0
                  then numero_racine:= l_page.numero_page_0;
                l_doit_consolider:= false;
              end
            else begin
                consolide(l_pile[l_sommet_pile].numero_page_mere, l_numero_page,
                    l_pile[l_sommet_pile].indice_mere);
                l_numero_page:= l_pile[l_sommet_pile].numero_page_mere;
              end;
        end; 
      end; 
    end; 
