(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)


    procedure affiche_parametres_de_balayage(p_tampon_balayage: t_tampon_balayage);
      var l_champ: integer;
      begin
      end; 
    procedure initialise_balayage(var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        p_ligne_debut, p_ligne_fin_max, p_colonne_max: integer);
      begin 
        initialise_groupe_de_champs(pv_groupe_champs);
        fillchar(pv_tampon_balayage, sizeof(pv_tampon_balayage), 0);
        pv_tampon_balayage.ligne_debut:= p_ligne_debut;
        pv_tampon_balayage.ligne_fin_max:= p_ligne_fin_max;
        pv_tampon_balayage.colonne_max:= p_colonne_max;
      end; 
    procedure initialise_champ_et_titre(var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        p_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
        p_gabarit: t_gabarit_max; p_titre: t_texte_titre);
      const kt_colonne_courante: integer= 1;
            kt_page_balayage: integer= 0;
      begin 
        with pv_tampon_balayage, p_pt_descripteur_de_zone^ do
        begin
          if pv_groupe_champs.pt_page_debut= nil
            then begin
                kt_page_balayage:= 0;
                kt_colonne_courante:= 1;
              end;
          if 1+ kt_colonne_courante+ taille_zone> colonne_max
            then begin
                kt_page_balayage:= kt_page_balayage+ 1;
                kt_colonne_courante:= 1;
              end;
          case type_zone of
            'C' : initialise_champ(pv_groupe_champs,
                      p_pt_descripteur_de_zone,
                      kt_page_balayage, 0, kt_colonne_courante,
                      taille_zone, 0,
                      p_gabarit, taille_fiche_tampon);
            'N' : initialise_champ(pv_groupe_champs,
                      p_pt_descripteur_de_zone,
                      kt_page_balayage, 0, kt_colonne_courante,
                      taille_zone, decimales_zone,
                      p_gabarit, taille_fiche_tampon);
            'L' : initialise_champ(pv_groupe_champs,
                      p_pt_descripteur_de_zone,
                      kt_page_balayage, 0, kt_colonne_courante,
                      1, 0,
                      p_gabarit, taille_fiche_tampon);
            'D' : initialise_champ(pv_groupe_champs,
                      p_pt_descripteur_de_zone,
                      kt_page_balayage, 0, kt_colonne_courante,
                      8, 0,
                      p_gabarit, taille_fiche_tampon);
            'M' : initialise_champ(pv_groupe_champs,
                      p_pt_descripteur_de_zone,
                      kt_page_balayage, 0, kt_colonne_courante,
                      1, 0,
                      p_gabarit, taille_fiche_tampon);
          end; 
          initialise_titre(pv_groupe_champs, kt_page_balayage, 1, kt_colonne_courante,
                        nom_zone);
          kt_colonne_courante:= kt_colonne_courante+ taille_zone+ 1;
          taille_fiche_tampon:= taille_fiche_tampon+ taille_zone;
        end; 
      end; 
    procedure initialise_balayage_standard(p_pt_fichier_donnees: t_pt_fichier_donnees;
        var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        p_ligne_debut, p_ligne_fin_max, p_colonne_max: integer);
      var l_numero_zone: integer;
          l_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
      begin
        initialise_balayage(pv_groupe_champs, pv_tampon_balayage,
          p_ligne_debut, p_ligne_fin_max, p_colonne_max);
        for l_numero_zone:= 0 to f_nombre_zones(p_pt_fichier_donnees)- 1 do
        begin
          l_pt_descripteur_de_zone:=
              f_pt_descripteur_zone(p_pt_fichier_donnees, l_numero_zone);
          initialise_champ_et_titre(pv_groupe_champs, pv_tampon_balayage,
            l_pt_descripteur_de_zone,
            '', l_pt_descripteur_de_zone^.nom_zone);
        end; 
        pv_tampon_balayage.teste_balayage:= false;
      end; 
