(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+,v-*)

program affiche_fichiers_index;
  uses crt;
  type t_string_80= string[80];
       t_string_255= string[255];
  (*$i a:isortie *)
  var g_choix: char;
      g_nom_index: t_string_80;

  procedure affiche_chaine_0_max(var pv_chaine_0; var pv_taille: integer);
    var l_chaine_surtypee: array[0..255] of char absolute pv_chaine_0;
        l_indice_chaine: integer;
    begin
      l_indice_chaine:= 0;
      while (l_indice_chaine< pv_taille)
          and (l_chaine_surtypee[l_indice_chaine]<> chr(0)) do
      begin
        write(g_sortie, l_chaine_surtypee[l_indice_chaine]);
        l_indice_chaine:= l_indice_chaine+ 1;
      end;
      pv_taille:= l_indice_chaine;
    end; 

  procedure affiche_fichier_index;
    type t_en_tete_index= record
                            racine: longint;
                            premiere_page_libre: longint;
                            remplissage_1, remplissage_2: integer;
                            taille_cle: integer;
                            cle_par_page_max: integer;
                            remplissage_3: integer;
                            taille_cellule: integer;
                            remplissage_4, remplissage_5: integer;
                            nom_cle: array[0..9] of char;
                            remplissage: array[0..477] of byte;
                          end;
         t_cle= array[0..100] of char;
         t_cellule= record
                      numero_sous_arbre: longint;
                      numero_fiche: longint;
                      cle: t_cle;
                    end;
         t_page_index= record
                         case integer of
                           1 : (en_tete: t_en_tete_index);
                           2 : (nombre_cellules_utilisees: longint;
                                tableau_positions: array[0..507] of byte);
                       end;
    var l_index: file of t_page_index;
        l_en_tete, l_page: t_page_index;
        l_numero_page: integer;
        l_taille_nom: integer;

    procedure affiche_page_index;
      var l_numero_cellule: integer;
          l_cellule: t_cellule;

      procedure affiche_cellule(var pv_cellule);
        var l_surtypage_cellule: t_cellule absolute pv_cellule;
            l_taille: integer;
        begin
          with l_surtypage_cellule do
          begin
            write(g_sortie, numero_sous_arbre: 4, numero_fiche: 4, ' ');
            l_taille:= l_en_tete.en_tete.taille_cle;
            affiche_chaine_0_max(cle, l_taille);
            write(g_sortie, '-');
          end; 
        end; 

      begin 
        with l_page do
        begin
          write(g_sortie, nombre_cellules_utilisees: 7, '   | ');
          for l_numero_cellule:= 1 to nombre_cellules_utilisees do
            affiche_cellule(tableau_positions[(l_numero_cellule- 1)* l_en_tete.en_tete.taille_cellule]);
          writeln(g_sortie);
        end;  
      end; 

    begin 
      assign(l_index, g_nom_index+ '.NDX');
      reset(l_index);
      read(l_index, l_en_tete);
      with l_en_tete.en_tete do
      begin
        writeln(g_sortie, 'racine           ', racine);
        writeln(g_sortie, 'page suivante    ', premiere_page_libre);
        writeln(g_sortie, 'taille cl       ', taille_cle);
        writeln(g_sortie, 'cl par page max ', cle_par_page_max);
        writeln(g_sortie, 'taille cellule   ', taille_cellule);
        l_taille_nom:= 10;
        write  (g_sortie, 'nom cl          ');
        affiche_chaine_0_max(nom_cle, l_taille_nom); writeln;
      end; 
      l_numero_page:= 1;
      writeln(g_sortie, 'numro nombre | cellules:');
      while not eof(l_index) do
      begin
        write(g_sortie, l_numero_page: 3, ' ');
        read(l_index, l_page);
        affiche_page_index;
        l_numero_page:= l_numero_page+ 1;
      end; 
      close(l_index);
    end; 

  procedure entre_nom_fichier;
    begin
      write(g_sortie, 'nom fichier <CLIENT> ? '); readln(g_nom_index);
    end; 

  procedure initialise;
    begin
      g_nom_index:= 'B:GCLIENTS';
      initialise_sortie;
    end; 

  begin 
    initialise;
    repeat
      writeln;
      writeln(g_nom_index, ' -> ', g_nom_sortie);
      write('Nom, Affiche, Sortie, Quitte ? ');
      g_choix:= upcase(readkey); writeln(g_choix);
      case g_choix of
        'A' : affiche_fichier_index;
        'N' : entre_nom_fichier;
        'S' : choisis_sortie;
      end;
    until g_choix= 'Q';
    ferme_sortie;
  end. 
