(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)


      procedure met_ligne_courante_en_video_inverse(p_pt_page: t_pt_page);
        var l_pt_champ_1: t_pt_champ;
        begin
          with p_pt_page^ do
          begin
            l_pt_champ_1:= pt_champ_debut;
            while l_pt_champ_1<> nil do
            begin
              with l_pt_champ_1^ do
                inverse_champ(l_ligne, colonne_champ, taille_champ);
              l_pt_champ_1:= l_pt_champ_1^.pt_champ_suivant;
            end; 
          end ; 
        end; 

      procedure met_ligne_courante_en_video_normale(p_pt_page: t_pt_page);
        var l_pt_champ_1: t_pt_champ;
        begin
          with p_pt_page^ do
          begin
            l_pt_champ_1:= pt_champ_debut;
            while l_pt_champ_1<> nil do
            begin
              with l_pt_champ_1^ do
                met_champ_en_video_normale(l_ligne, colonne_champ, taille_champ);
              l_pt_champ_1:= l_pt_champ_1^.pt_champ_suivant;
            end; 
          end; 
        end; 

      procedure affiche_les_titres(p_pt_page: t_pt_page);
        var l_numero_champ: integer;
        var l_pt_titre: t_pt_titre;
        begin
          with p_pt_page^ do
          begin
            l_pt_titre:= pt_titre_debut;
            while l_pt_titre<> nil do
            begin
              affiche_titre(l_pt_titre);
              l_pt_titre:= l_pt_titre^.pt_titre_suivant;
            end; 
          end; 
        end; 

      procedure affiche_ligne(p_pt_page: t_pt_page; p_ligne: integer);
        var l_pt_champ_1: t_pt_champ;
            l_pt_valeur: pointer;
        begin
          with p_pt_page^ do
          begin
            l_pt_champ_1:= pt_champ_debut;
            while l_pt_champ_1<> nil do
            begin
              with l_pt_champ_1^, pv_tampon_balayage do
              begin
                gotoxy(colonne_champ, p_ligne);
                (*$r-*)
                l_pt_valeur:= addr(pt_table_fiches^[p_ligne- ligne_debut]^.donnee[position_tampon]);
                (*$r+*)
                case pt_descripteur_de_zone^.type_zone of
                  'C' : affiche_chaine_db(l_pt_valeur^, taille_champ);
                  'N' : affiche_chaine_db_numerique(l_pt_valeur^, taille_champ, decimales_champ,
                             gabarit_champ);
                  'L' : affiche_chaine_db(l_pt_valeur^, 1);
                  'D' : affiche_chaine_db_date(l_pt_valeur^);
                  'M' : write('M');
                end; 
                if teste_balayage
                  then begin
                      gotoxy(60, p_ligne);
                      write('&', pt_table_fiches^[p_ligne- ligne_debut]^.numero_fiche);
                   end;
              end; 
              l_pt_champ_1:= l_pt_champ_1^.pt_champ_suivant;
            end; 
          end; 
        end; 

      procedure affiche_page(p_pt_page: t_pt_page);
        var l_ligne_affichage: integer;
        begin
          clrscr;
          affiche_les_titres(p_pt_page);
          with pv_groupe_champs, pv_tampon_balayage do
          begin
            l_ligne_affichage:= ligne_debut;
            (*$r-*)
            while l_ligne_affichage<= ligne_fin do
            (*$r+*)
            begin
              affiche_ligne(p_pt_page, l_ligne_affichage);
              l_ligne_affichage:= l_ligne_affichage+ 1;
            end; 
          end; 
        end; 

      procedure dump_tampon;
        var l_ligne: integer;
        begin
          gotoxy(1, 14);
          with pv_groupe_champs, pv_tampon_balayage do
            for l_ligne:= ligne_debut to ligne_fin do
              with pt_table_fiches^[l_ligne- ligne_debut]^ do
                affiche_memoire(pt_table_fiches^[l_ligne- ligne_debut]^, 8);
        end; 

      procedure saisis_les_champs;
        var l_pt_valeur: ^t_fiche_balayage;

        procedure teste_page_est;
          begin
            with pv_groupe_champs do
            begin
              l_pt_page:= l_pt_page^.pt_page_suivante;
              if l_pt_page<> nil
                then begin
                    l_pt_champ:= l_pt_page^.pt_champ_debut;
                    affiche_page(l_pt_page);
                    g_parametres_saisie.caractere_sortie_de_champ:= k_rien_faire;
                  end;
            end; 
          end; 

        procedure teste_page_ouest;
          begin
            with pv_groupe_champs do
            begin
              l_pt_page:= l_pt_page^.pt_page_precedente;
              if l_pt_page<> nil
                then begin
                    l_pt_champ:= l_pt_page^.pt_champ_fin;
                    affiche_page(l_pt_page);
                    g_parametres_saisie.caractere_sortie_de_champ:= k_rien_faire;
                  end;
            end; 
          end; 

        procedure traite_sortie_de_groupe;
          begin
            with g_parametres_saisie, pv_groupe_champs, pv_tampon_balayage do
            begin
              if (l_pt_champ= nil)
                  and (caractere_sortie_de_champ in [k_curseur_est, k_return, k_page_est])
                then begin
                    caractere_sortie_de_champ:= k_curseur_sud;
                    l_pt_page:= pt_page_debut;
                    l_pt_champ:= pt_page_debut^.pt_champ_debut;
                    position_dans_champ:= 0;
                    affiche_page(l_pt_page);
                  end;
              if (l_pt_champ= nil)
                  and (caractere_sortie_de_champ
                      in [k_curseur_ouest, k_efface_avant_curseur, k_page_ouest])
                then begin
                    l_pt_page:= pt_page_fin;
                    l_pt_champ:= pt_page_fin^.pt_champ_fin;
                    position_dans_champ:= l_pt_champ^.taille_champ- 1;
                    affiche_page(l_pt_page);
                  end;
            end; 
          end; 

        begin 
          with g_parametres_saisie, pv_groupe_champs, pv_tampon_balayage do
          begin
            a_modifie_un_champ_du_groupe:= false;
            caractere_sortie_de_champ:= ' ';
            repeat
              with l_pt_champ^ do
              begin
                if teste_balayage
                  then begin
                      gotoxy(50, 1);
                      write(ligne_debut: 3, l_ligne: 3, ligne_fin: 3, ligne_fin_max: 3);
                      dump_tampon;
                    end;
                (*$r-*)
                l_pt_valeur:= addr(pt_table_fiches^[l_ligne- ligne_debut]^.donnee[position_tampon]);
                (*$r+*)
                met_ligne_courante_en_video_inverse(l_pt_page);
                with pt_descripteur_de_zone^ do
                  case type_zone of
                    'C' : saisis_chaine_db(l_ligne, colonne_champ, position_dans_champ, taille_champ,
                            l_pt_valeur^, gabarit_champ, 'C');
                    'N' : saisis_chaine_db_numerique(l_ligne, colonne_champ, position_dans_champ,
                            taille_champ, decimales_champ,
                            taille_zone, decimales_zone,
                            l_pt_valeur^, gabarit_champ);
                    'L' : saisis_booleen(l_ligne, colonne_champ, position_dans_champ,
                            l_pt_valeur^);
                    'D' : saisis_chaine_db_date(l_ligne, colonne_champ, position_dans_champ,
                            taille_champ, l_pt_valeur^, gabarit_champ);
                    'M' : saisis_zone_memo(l_ligne, colonne_champ, l_pt_valeur^, p_pt_fichier_memo);
                  end; 
                met_ligne_courante_en_video_normale(l_pt_page);
                a_modifie_un_champ_du_groupe:=
                  a_modifie_un_champ_du_groupe or a_modifie_le_champ;
                l_a_modifie_cle:= a_modifie_le_champ and (position_tampon= position_cle);
                case caractere_sortie_de_champ of
                  k_efface_avant_curseur,
                    k_curseur_ouest :
                      begin
                        l_pt_champ:= l_pt_champ^.pt_champ_precedent;
                        if l_pt_champ= nil
                          then teste_page_ouest
                          else begin
                              position_dans_champ:= l_pt_champ^.taille_champ- 1;
                              caractere_sortie_de_champ:= k_rien_faire;
                            end;
                      end;
                  k_curseur_est,
                    k_return : begin
                                 l_pt_champ:= l_pt_champ^.pt_champ_suivant;
                                 position_dans_champ:= 0;
                                 if l_pt_champ= nil
                                   then teste_page_est
                                   else 
                                       caractere_sortie_de_champ:= k_rien_faire;
                               end;
                  k_page_est : begin
                                 teste_page_est;
                                 if l_pt_page= nil
                                   then l_pt_champ:= nil;
                               end;
                  k_page_ouest : begin
                                   teste_page_ouest;
                                   if l_pt_page= nil
                                     then l_pt_champ:= nil;
                                 end;
                  k_page_suivante, k_page_precedente,
                    k_curseur_sud, k_curseur_nord,
                    k_escape, k_controle_end : ;
                  else
                    affiche_erreur('mauvaise touche de sortie de ligne ');
                    affiche_touche(caractere_sortie_de_champ);
                    caractere_sortie_de_champ:= k_rien_faire;
                end; 
                traite_sortie_de_groupe;
              end; 
            until (caractere_sortie_de_champ in caracteres_sortie_de_champ)
              or (l_pt_champ= nil);
          end; 
        end; 
