(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
unit uaffiche;
  interface
    uses utypcons, usortie;

    procedure affiche_chaine_0(var pv_chaine_db; var pv_taille: integer);

    procedure affiche_chaine_db(var pv_chaine_db; p_taille: integer);

    procedure formate_chaine_db_numerique(var pv_chaine_db_numerique: t_chaine_db_numerique_max;
        p_taille_chaine, p_decimales_chaine: integer;
        var v_gabarit_d_affichage: t_gabarit_max);

    procedure affiche_chaine_db_numerique(var pv_chaine_db_numerique;
        p_taille, p_decimales: integer;
        var v_gabarit: t_gabarit_max);

    procedure formate_chaine_db_date(p_date: t_date; var pv_date: t_date);

    procedure affiche_chaine_db_date(var pv_date);
  implementation

    procedure affiche_chaine_0(var pv_chaine_db; var pv_taille: integer);
      var l_chaine_surtypee: t_chaine_db_max absolute pv_chaine_db;
      begin
        pv_taille:= 0;
        while l_chaine_surtypee[pv_taille]<> chr(0) do
        begin
          write(g_sortie.sortie, l_chaine_surtypee[pv_taille]);
          pv_taille:= pv_taille+ 1;
        end;
      end; 

    procedure affiche_chaine_db(var pv_chaine_db; p_taille: integer);
      var l_chaine_surtypee: t_chaine_db_max absolute pv_chaine_db;
          l_indice_chaine: integer;
      begin
        for l_indice_chaine:= 0 to p_taille- 1 do
          write(g_sortie.sortie, l_chaine_surtypee[l_indice_chaine]);
      end; 

    procedure formate_chaine_db_numerique(var pv_chaine_db_numerique: t_chaine_db_numerique_max;
        p_taille_chaine, p_decimales_chaine: integer;
        var v_gabarit_d_affichage: t_gabarit_max);
      var l_indice_point_gabarit_max, l_taille_gabarit: integer;
          l_indice_point_chaine, l_indice_premier_chiffre_chaine: integer;
          l_decalage_des_points: integer;
          l_indice: integer;
          l_tronque_partie_entiere, l_tronque_decimales: boolean;
      begin
        l_indice_point_gabarit_max:= 1;
        l_taille_gabarit:= length(v_gabarit_d_affichage);
        while (l_indice_point_gabarit_max<= l_taille_gabarit)
            and (v_gabarit_d_affichage[l_indice_point_gabarit_max]<> '.') do
          l_indice_point_gabarit_max:= l_indice_point_gabarit_max+ 1;
        if (l_indice_point_gabarit_max<= l_taille_gabarit) and (p_decimales_chaine= 0)
          then begin
              pv_chaine_db_numerique[p_taille_chaine]:= '.';
              p_taille_chaine:= p_taille_chaine+ 1;
              pv_chaine_db_numerique[p_taille_chaine+ 1]:= '0';
              p_taille_chaine:= p_taille_chaine+ 2;
              p_decimales_chaine:= 1;
            end;
  
        if p_decimales_chaine= 0
          then l_indice_point_chaine:= p_taille_chaine
          else l_indice_point_chaine:= p_taille_chaine- p_decimales_chaine- 1;
        l_decalage_des_points:= l_indice_point_gabarit_max- 1- l_indice_point_chaine;
  
        l_indice_premier_chiffre_chaine:= 0;
        while (l_indice_premier_chiffre_chaine< p_taille_chaine)
            and (pv_chaine_db_numerique[l_indice_premier_chiffre_chaine]= ' ') do
          l_indice_premier_chiffre_chaine:= l_indice_premier_chiffre_chaine+ 1;
  
        l_tronque_partie_entiere:= false;
        l_tronque_decimales:= false;
        if l_decalage_des_points> 0
          then begin
              if p_taille_chaine+ l_decalage_des_points> l_taille_gabarit
                then begin
                    l_tronque_decimales:= true;
                    p_taille_chaine:= l_taille_gabarit- l_decalage_des_points;
                  end;
  
              move(pv_chaine_db_numerique, pv_chaine_db_numerique[l_decalage_des_points],
                   p_taille_chaine);
  
              fillchar(pv_chaine_db_numerique, l_decalage_des_points, ' ');
  
              p_taille_chaine:= p_taille_chaine+ l_decalage_des_points;
              l_indice_premier_chiffre_chaine:= l_indice_premier_chiffre_chaine
                + l_decalage_des_points;
            end 
          else
            if l_decalage_des_points< 0
              then
  
                if l_indice_point_chaine- l_indice_premier_chiffre_chaine>
                    l_indice_point_gabarit_max- 1
                  then begin
  
                      p_taille_chaine:= p_taille_chaine+ l_decalage_des_points;
                      l_indice_premier_chiffre_chaine:= l_indice_point_chaine
                         - (l_indice_point_gabarit_max- 1);
                      move(pv_chaine_db_numerique[l_indice_point_chaine
                                                 - (l_indice_point_gabarit_max- 1)],
                           pv_chaine_db_numerique,
                         p_taille_chaine);
                      l_tronque_partie_entiere:= true;
                    end
                  else begin
                      move(pv_chaine_db_numerique[-l_decalage_des_points],
                           pv_chaine_db_numerique,
                           p_taille_chaine- l_decalage_des_points);
                      p_taille_chaine:= p_taille_chaine+ l_decalage_des_points;
                      l_indice_premier_chiffre_chaine:= l_indice_premier_chiffre_chaine
                        + l_decalage_des_points;
                    end; 
        l_indice:= l_indice_point_gabarit_max- 1;
        (*$r-*)
        while (l_indice> 0) and (pv_chaine_db_numerique[l_indice- 1] in ['0'..'9']) do
        (*$r+*)
        begin
          if v_gabarit_d_affichage[l_indice]= ','
            then begin
                if l_indice_premier_chiffre_chaine<= 0
                  then l_tronque_partie_entiere:= true;
                 move(pv_chaine_db_numerique[1], pv_chaine_db_numerique[0], l_indice- 1);
                 pv_chaine_db_numerique[l_indice- 1]:= ',';
                 l_indice_premier_chiffre_chaine:= l_indice_premier_chiffre_chaine- 1;
              end; 
          l_indice:= l_indice- 1;
        end; 
        l_indice:= l_indice_point_gabarit_max+ 1;
        while (l_indice<= l_taille_gabarit) and (pv_chaine_db_numerique[l_indice- 1] in ['0'..'9']) do
        begin
          if v_gabarit_d_affichage[l_indice]= ','
            then begin
                if p_taille_chaine>= l_taille_gabarit
                  then begin
                      p_taille_chaine:= l_taille_gabarit- 1;
                      l_tronque_decimales:= true;
                    end;
  
                move(pv_chaine_db_numerique[l_indice- 1],
                     pv_chaine_db_numerique[l_indice],
                     p_taille_chaine+ 1- l_indice);
                pv_chaine_db_numerique[l_indice- 1]:= ',';
                p_taille_chaine:= p_taille_chaine+ 1;
              end; 
  
          l_indice:= l_indice+ 1;
        end; 
        for l_indice:= p_taille_chaine+ 1 to l_taille_gabarit do
        begin
          if v_gabarit_d_affichage[l_indice]= ','
            then pv_chaine_db_numerique[p_taille_chaine]:= ','
            else pv_chaine_db_numerique[p_taille_chaine]:= '0';
          p_taille_chaine:= p_taille_chaine+ 1
        end;
        if l_tronque_partie_entiere
          then
            for l_indice:= 0 to p_taille_chaine- 1 do
              if pv_chaine_db_numerique[l_indice] in ['0'..'9']
                then pv_chaine_db_numerique[l_indice]:= '*';
      end; 

    procedure affiche_chaine_db_numerique(var pv_chaine_db_numerique;
        p_taille, p_decimales: integer;
        var v_gabarit: t_gabarit_max);
      var l_chaine_db_numerique_surtypee: t_chaine_db_numerique_max
            absolute pv_chaine_db_numerique;
          l_chaine_db_numerique: t_chaine_db_numerique_max;
      begin
        if v_gabarit= ''
          then affiche_chaine_db(l_chaine_db_numerique_surtypee, p_taille)
          else begin
              l_chaine_db_numerique:= l_chaine_db_numerique_surtypee;
              formate_chaine_db_numerique(l_chaine_db_numerique, p_taille, p_decimales,
                  v_gabarit);
              affiche_chaine_db(l_chaine_db_numerique, length(v_gabarit));
            end;
      end; 
  
  

    procedure formate_chaine_db_date(p_date: t_date; var pv_date: t_date);
      begin
        pv_date:= p_date;
        move(pv_date[2], pv_date[1], 4);
  
        pv_date[5]:= '/';
        move(pv_date[1], pv_date[0], 2);
  
        pv_date[2]:= '/';
      end; 
  

    procedure affiche_chaine_db_date(var pv_date);
      var l_date_surtypee: t_date absolute pv_date;
          l_date: t_date;
      begin
        formate_chaine_db_date(l_date_surtypee, l_date);
        affiche_chaine_db(l_date, 8);
      end; 

  begin 
  end. 





