(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
unit uclavier;
  interface
    uses dos;
    const 
          k_efface_avant_curseur= #08;
          k_tabule= #9;
          k_return= #13;
          k_interligne= #10;
          k_controle_z= #26;
          k_escape= #27;
          k_curseur_est= #160;
          k_curseur_ouest= #161;
          k_curseur_nord= #162;
          k_curseur_sud= #163;
          k_mot_precedent= #164; 
          k_mot_suivant= #165;   
          k_page_precedente= #166; 
          k_page_suivante= #167;   
          k_page_ouest= #168; 
          k_page_est= #169;   
          k_efface_sous_curseur= #170; 
          k_remplace_insere= #171;     
          k_rien_faire= #172;
          k_controle_end= #173; 
          k_controle_home= #174; 

    procedure lis_touche(var pv_touche: char);

    procedure affiche_touche(p_touche: char);
  implementation

    procedure lis_touche(var pv_touche: char);
      var l_registres_8086: registers;
          l_al: char;
      begin
        with l_registres_8086 do
        begin
          ax:= $0000;
          intr($16, l_registres_8086);
          l_al:= chr(al);
          if l_al= k_controle_z
            then begin
                write('  >>> HALT <<< ');
                halt;
              end;
          if l_al= #0
            then
              case ah of
                72 : l_al:= k_curseur_nord;
                75 : l_al:= k_curseur_ouest;
                77 : l_al:= k_curseur_est;
                80 : l_al:= k_curseur_sud;
                83 : l_al:= k_efface_sous_curseur;
                82 : l_al:= k_remplace_insere;
                71 : l_al:= k_mot_precedent;
                79 : l_al:= k_mot_suivant;
                73 : l_al:= k_page_precedente;
                81 : l_al:= k_page_suivante;
                115 : l_al:= k_page_ouest;
                116 : l_al:= k_page_est;
                117 : l_al:= k_controle_end;
                119 : l_al:= k_controle_home;
              end; 
          pv_touche:= l_al;
        end; 
      end; 

  procedure affiche_touche(p_touche: char);
    begin
      case p_touche of
        k_curseur_nord : write('curseur nord');
        k_curseur_ouest : write('curseur ouest');
        k_curseur_est : write('curseur est');
        k_curseur_sud : write('curseur sud');
        k_efface_sous_curseur : write('efface sous curseur');
        k_remplace_insere : write('ins');
        k_mot_precedent : write('mot prcdent');
        k_mot_suivant : write('mot suivant');
        k_page_precedente : write('page prcdente');
        k_page_suivante : write('page suivante');
        k_page_ouest : write('page ouest');
        k_page_est : write('page est');
        k_controle_end : write('Ctrl End');
        k_efface_avant_curseur : write('efface avant curseur');
        k_tabule : write('tabule');
        k_return : write('return');
        k_controle_z : write('Ctrl z');
        k_escape : write('escape');
        else write(' ', ord(p_touche), ' ');
      end; 
    end; 

  begin 
  end. 

