(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
unit usaisfic;
  interface
    uses crt,
         uclavier, uerreur,
         usaisis,
         udonnees, uchamps, umemo;

    procedure saisis_fiche_a_fiche(p_pt_fichier_donnees: t_pt_fichier_donnees;
        p_numero_fiche: integer;
        p_groupe_champs: t_groupe_champs;
        p_pt_fichier_memo: t_pt_fichier_memo);
  implementation

    procedure saisis_fiche_a_fiche(p_pt_fichier_donnees: t_pt_fichier_donnees;
        p_numero_fiche: integer;
        p_groupe_champs: t_groupe_champs;
        p_pt_fichier_memo: t_pt_fichier_memo);
      var l_pt_page: t_pt_page;
          l_pt_champ: t_pt_champ;
          l_nombre_fiches: integer;

      procedure cherche_la_fiche_suivante;
        begin
          if p_pt_fichier_donnees^.a_modifie_fiche
            then begin
                positionne_fiche_courante(p_pt_fichier_donnees, p_numero_fiche);
                ecris_fiche_courante(p_pt_fichier_donnees);
              end;
          p_numero_fiche:= p_numero_fiche+ 1;
        end; 

      procedure cherche_la_fiche_precedente;
        begin
          if p_pt_fichier_donnees^.a_modifie_fiche
            then begin
                positionne_fiche_courante(p_pt_fichier_donnees, p_numero_fiche);
                ecris_fiche_courante(p_pt_fichier_donnees);
              end;
          if p_numero_fiche= 0
            then sonne
            else p_numero_fiche:= p_numero_fiche- 1;
          positionne_fiche_courante(p_pt_fichier_donnees, p_numero_fiche);
        end; 

      begin 
        with g_parametres_saisie, p_groupe_champs, p_pt_fichier_donnees^ do
        begin
          positionne_fiche_courante(p_pt_fichier_donnees, p_numero_fiche);
          position_dans_champ:= 0;
          l_pt_page:= pt_page_debut;
          l_pt_champ:= l_pt_page^.pt_champ_debut;
          repeat
            l_nombre_fiches:= f_nombre_fiches(p_pt_fichier_donnees);
            if p_numero_fiche> l_nombre_fiches
              then p_numero_fiche:= l_nombre_fiches;
            if p_numero_fiche= l_nombre_fiches
              then initialise_fiche_courante(p_pt_fichier_donnees)
              else lis_fiche_courante(p_pt_fichier_donnees);
            affiche_champs_de_la_page(l_pt_page);
            saisis_groupe_de_champs(p_groupe_champs,
                l_pt_page, l_pt_champ, position_dans_champ,
                p_numero_fiche= l_nombre_fiches, p_pt_fichier_memo);
            a_modifie_fiche:= a_modifie_un_champ_du_groupe;
            case caractere_sortie_de_champ of
              k_curseur_sud, k_curseur_est, k_page_suivante,
                k_return : cherche_la_fiche_suivante;
              k_curseur_nord, k_page_precedente,
                k_curseur_ouest : cherche_la_fiche_precedente;
            end; 
          until caractere_sortie_de_champ in caracteres_sortie_fiche_a_fiche;
          if a_modifie_fiche and (caractere_sortie_de_champ<> k_escape)
            then begin
                positionne_fiche_courante(p_pt_fichier_donnees, p_numero_fiche);
                ecris_fiche_courante(p_pt_fichier_donnees);
              end;
        end; 
      end; 

  begin 
  end. 
