; 007 cassasob
; 01 sep 88

; 24 jul 91

; compilateur dbase en assembleur


                code
                org    $0100

                ; saute dans source principal
                jmp    principal


;$i iaecran
;$i iaclavier
;$i iafichier
;$i iasource
;$i iaobjet



;--------------------------------------
; le source principal
;--------------------------------------

                data

k_segment_ds                 equ    $3000

; gestion des erreurs
v_sp_erreur                  equ    $0016 ; 2
; mise au point
v_teste                      equ    $0112 ; 1 octet



                code

principal
                call   initialise

.principal      call   a_la_ligne
                call   affiche_status
                call   a_la_ligne

                call   affiche_chaine
                asc    'Nom, Charge, Affiche, Librairie, Interprete, Sauve objet, Teste, Quitte ? '
                hex    00

                call   lis_caractere
                call   a_la_ligne

                cmp    al, 'a'
                jne    .charge_source
                call   affiche_source
                jmp    .principal

.charge_source
                cmp    al, 'c'
                jne    .entre_nom
                call   charge_source
                jmp    .principal

.entre_nom      cmp    al, 'n'
                jne    .compile
                call   entre_nom_source
                jmp    .principal

.compile     cmp    al, 'i'
                jne    .sauve
                call   compile
                jmp    .principal

.sauve          cmp    al, 's'
                jne    .clrscr
                call   sauve_objet
                jmp    .principal

.clrscr         cmp    al, ' '
                jne    .debug
                call   clrscr
                call   initialise_curseur
                jmp    .principal

.debug          cmp    al, 't'
                jne    .objet
                call   bascule_debug
                jmp    .principal

.objet          cmp    al, 'l'
                jne    .quitte
                call   charge_librairie
                jmp    .principal

.quitte         cmp    al, 'q'
                je     .fin
                jmp    .principal

.fin
                ret    ; principal



initialise      ; installe DS
                ; ?? bug assy ds
                ; mov   ds, k_segment_ds
                mov    dx, k_segment_ds
                mov    ds, dx

                ; le nom de source par dfaut: S
                mov    si, v_nom_source
                mov    al, 's'
                mov    [si], al
                inc    si
                mov    al, $00
                mov    [si], al

                ; le nom de la librairfie par dfaut: L
                mov    si, v_nom_librairie
                mov    al, 'l'
                mov    [si], al
                inc    si
                mov    al, $00
                mov    [si], al

                ; cre le nom de l'objet par dfaut: O.COM
                mov    si, v_nom_objet
                mov    al, 'o'
                mov    [si], al
                inc    si
                mov    al, '.'
                mov    [si], al
                inc    si
                mov    al, 'c'
                mov    [si], al
                inc    si
                mov    al, 'o'
                mov    [si], al
                inc    si
                mov    al, 'm'
                mov    [si], al
                inc    si
                mov    al, $00
                mov    [si], al

                ; pour le moment aucun texte charg
                mov    w [v_debut_texte], k_decalage_source
                mov    w [v_fin_texte], $0000

                ; pour le moment aucun objet
                mov    w [v_indice_objet], $0000

                ;  la moindre erreur, retombe dans le menu
                mov    [v_sp_erreur], sp

                ; ne pas afficher le source
                mov    b [v_teste], $00

                ; purge l'cran
                call   clrscr
                call   initialise_curseur
                ret    ; initialise



affiche_status  ; affichages divers dans la boucle principale
                mov    si, v_nom_source
                call   affiche_chaine_0

                call   affiche_espace
                mov    dx, [v_debut_texte]
                call   affiche_hex_dx

                call   affiche_espace
                mov    dx, [v_fin_texte]
                call   affiche_hex_dx

                call   affiche_chaine
                asc    ' -> '
                hex    00

                mov    si, v_nom_objet
                call   affiche_chaine_0

                call   affiche_espace
                mov    dx, [v_indice_objet]
                call   affiche_hex_dx

                call   affiche_espace
                push   sp
                pop    dx
                call   affiche_hex_dx

                call   affiche_espace
                mov    al, [v_teste]
                call   affiche_hex_al

                call   affiche_chaine
                asc    ' ZZZ '
                hex    00

                ret    ; affiche_status



bascule_debug
                cmp    b [v_teste], $00
                jne    .mets_debug
                mov    b [v_teste], $01
                jmp_s  .fin
.mets_debug     mov    b [v_teste], $00
.fin            ret

affiche_car_test
                cmp     b [v_teste], $00
                je      .fin
                call    affiche_car
.fin            ret



affiche_chaine_test
                ; affiche une chane situe aprs le CALL
                ; et termine par 0

                seg    cs
                mov    [v_sauve_bx], bx
                seg    cs
                mov    [v_sauve_ax], ax

                ; rcupre l'emplacement de la chaine
                pop    bx

.affiche        seg    cs
                mov    al, [bx]

                inc    bx

                cmp    al, $00
                je     .ret

                cmp    b [v_teste], $00
                je     .affiche

                call   affiche_car
                jmp_s  .affiche

.ret            ; veut revenir apres la chaine
                push   bx

                seg    cs
                mov    bx, [v_sauve_bx]
                seg    cs
                mov    ax, [v_sauve_ax]

                ret    ; affiche_chaine_test



affiche_hex_dx_test
               cmp     b [v_teste], $00
               je      .fin
               call    affiche_hex_dx
.fin           ret

affiche_hex_al_test
               cmp     b [v_teste], $00
               je      .fin
               call    affiche_hex_al
.fin           ret

stoppe_test
               cmp     b [v_teste], $00
               je      .fin
               call    stoppe
.fin           ret

a_la_ligne_test
               cmp     b [v_teste], $00
               je      .fin
               call    a_la_ligne
.fin           ret




;--------------------------------------
; le compilateur
;--------------------------------------

                data

; les erreurs signales
k_erreur_attend_instruction  equ    $01
k_erreur_attend_egal         equ    $02
k_erreur_attend_nom_variable equ    $03
k_erreur_attend_instruction_2 equ   $04
k_erreur_attend_un_chiffre   equ    $05
k_erreur_pas_cette_var       equ    $06
k_erreur_attend_chaine_litterale equ $07



                code

compile         ; DS contient les variables globales du compilateur
                ; SI dsigne l'indice du caractre du source
                ; DI dsigne la position de l'octet gnr

                call   affiche_chaine
                asc    'compile...'
                hex    00
                call   a_la_ligne

                call   initialise_compilation
                ; initialise la gestion des variables
                ; et lis le premier symbole
                call   compile_clear

.repete_mot     cmp    b [v_teste], $00
                je     .saute_debug

                push   bx
                call   affiche_chaine
                asc    'OK:'
                hex    00
                mov    al, [si]
                call   affiche_car
                call   affiche_espace
                call   affiche_symbole
                call   affiche_chaine
                asc    '=== '
                hex    00

                push   si
                call   affiche_status
                call   a_la_ligne
                pop    si
                call   stoppe
                pop    bx

.saute_debug    cmp    si, [v_fin_texte]
                jae    .ret

                call   compile_instruction

                jmp_s  .repete_mot

.ret            call   genere_ret
                mov    [v_indice_objet], di
                ret    ; compile



initialise_compilation
                call   charge_librairie

                ; remplit la table des variables avec des zros
                mov     ax, k_segment_ds
                mov     es, ax
                mov     di, v_debut_table_variables
                mov     ax, $0000
                mov     cx, $0100
                cld
                rep
                stos    w

                mov     w [v_indice_variable_suivante], v_debut_table_variables
                ; mise au point
                mov     w [v_indice_variable_courante], $FFFF

                ; dbut du source
                mov    si, [v_debut_texte]

                ; dbut de l'objet: aprs la librairie
                mov    di, [v_indice_objet]

                ret   ; initialise_interpretation



affiche_erreur_if_b
                jae    pas_erreur
                jmp_s  affiche_erreur

affiche_erreur_if_ne
                jne    affiche_erreur
                ; puis "tombe" dans le retour

pas_erreur      ; sauve BP
                push   bp
                ; modifie l'ardresse de retour pour sauter l'octet du numro
                ; de l'erreur
                mov    bp, sp
                inc    w [bp+ $02]
                pop    bp
                ret    ; pas_erreur

affiche_erreur
                call   affiche_chaine
                asc    'erreur'
                hex    00

                ; rcupre l'adresse de l'octet d'erreur
                mov    bp, sp
                mov    bx, [bp+ $00]
                seg    cs
                mov    al, [bx]

                call   affiche_hex_al
                call   stoppe

                ; avorte la interpretation
                mov    sp, [v_sp_erreur]
                ret    ; affiche_erreur



;$i ialexical
;$i iavariable


;--------------------------------------
; ventilation des commandes
;--------------------------------------

                code

compile_instruction
                ; ventile en fonction de l'instruction
                mov    al, [v_type_symbole]

                ; traite d'abord les mots correspondant  des mots rservs
                cmp    al, k_premier_mot_reserve
                call   affiche_erreur_if_b
                oct    k_erreur_attend_instruction

                cmp    al, k_dernier_mot_instruction
                jae    .autre_mot_reserve

.ventile        ; ici un mot rserv: CLEAR, IF .... Ventile en fonction
                ; de l'adresse contenue dans CS
                call   ventile_traitement
                jmp_s  .ret

.autre_mot_reserve
                ; rejette les mots rservs qui ne peuvent pas commencer
                ; une instruction
                cmp    al, k_premiere_ponctuation
                call   affiche_erreur_if_b
                oct    k_erreur_attend_instruction_2

                ; les ponctuations acceptes en dbut d'instruction: @, ?...
                cmp    al, k_symbole_interrogation
                ja     .arobas
                call   compile_interrogation
                jmp_s  .ret

.arobas         cmp    al, k_symbole_arobas
                ja     .autres
                call   compile_arobas
                jmp_s  .ret

.autres         cmp    al, k_derniere_ponctuation_instruction
                jb     .ventile

                ; reste plus que l'affectation
                call   compile_affectation

.ret            ret    ; compile_instruction



ventile_traitement
                ; saute  la routine dont l'adresse est pointe par CS:BX
                mov    bx, [v_adresse_traitement_reserve]
                seg    cs
                call   [bx]
                ret



compile_expression
                ; ?? seule "expression": valeur constante littrale
                call   affiche_chaine_test
                asc    ' CALCULE EXPR '
                hex    00

                ; call   lis_symbole
                cmp    b [v_type_symbole], k_symbole_nombre_litteral
                call   affiche_erreur_if_ne
                oct    k_erreur_attend_un_chiffre

                ; normalement compile_expression lit le symbole qui suit
                ; l'expression et qui indique que l'expression est termine
                call   lis_symbole

                call   affiche_chaine_test
                asc    ' FIN EXPR '
                hex    00

                ret ; compile expression




;--------------------------------------
; gnration du code
;--------------------------------------

                data

; -- les codes du 8086
k_code_call                   equ $E8;
k_code_mov_dx_immediat        equ $BA;
k_code_ret                    equ $C3;
k_code_seg_cs                 equ $2E;
k_code_mov_w_memoire_immediat equ $06C7;
k_code_mov_b_memoire_immediat equ $06C6;
k_code_mov_ax_memoire         equ $A1;
k_code_mov_memoire_ax         equ $A3;
k_code_mov_dx_memoire         equ $168B;
k_code_mov_memoire_bx         equ $1E89;
k_code_jmp                    equ $E9;
k_code_je                     equ $74;
k_code_cmp_w_memoire_immediat equ $3E81;

; -- les adresses de la librairie actuelle
k_adresse_curseur_x          equ $0103;
k_adresse_curseur_y          equ $0105;
k_adresse_affiche_hex_dx     equ $0108;
k_adresse_a_la_ligne         equ $016F;
k_adresse_initialise_curseur equ $01B8;
k_adresse_clrscr             equ $01C5;
k_adresse_affiche_chaine     equ $01EA;
k_adresse_stoppe             equ $021D;
k_adresse_lis_entier         equ $0229;



                code

; genere et affiche

genere_octet
                ; genere un octet et l'affiche
                push   ds
                push   bx

                ; ?? bug assy pascal
                mov    bx, k_segment_objet
                push   bx
                pop    ds

                mov    [di], al
                inc    di

                pop    bx
                pop    ds

                call   affiche_hex_al

                ret



genere_mot
                ; genere un octet et l'affiche
                push   ds
                push   bx

                ; ?? bug assy pascal
                mov    bx, k_segment_objet
                push   bx
                pop    ds

                mov    [di], ax
                inc    di
                inc    di

                pop    bx
                pop    ds

                ; affiche dans l'ordre inverse
                push   ax
                mov    dl, ah
                pop    ax
                mov    dh, al
                call   affiche_hex_dx

.ret            ret



genere_call     ; AX contient l'adresse absolue de la librairie
                push   ax
                mov    al, k_code_call
                call   genere_octet
                pop    ax

                sub    ax, di
                sub    ax, $0102

                call   genere_mot
                call   affiche_adresse
                ret


genere_ret      mov    ax, k_adresse_stoppe
                call   genere_call
                mov    al, k_code_ret
                call   genere_octet
                ret



affiche_adresse
                call   a_la_ligne
                mov    dx, di
                call   affiche_hex_dx
                call   affiche_chaine
                asc    ': '
                hex    00
                ret

;--------------------------------------
; le traitement des diverses commandes
;--------------------------------------

                code

compile_clear
                mov    ax, k_adresse_clrscr
                call   genere_call
                mov    ax, k_adresse_initialise_curseur
                call   genere_call

                call   affiche_chaine_test
                asc    ' COMPILE CLEAR '
                hex    00

                ; initialise la table des variables pour le compilateur
                mov    w [v_indice_variable_suivante], v_debut_table_variables

                ; ?? le masque

                call   lis_symbole

                call   a_la_ligne_test

                ret ; compile_clear



compile_interrogation
                ; attend expression  afficher
                ; ?? que nom variable
                call   affiche_chaine_test
                asc    'COMPILE ? '
                hex    00

                call   lis_symbole

                cmp    b [v_type_symbole], k_symbole_variable
                jne    .chaine_litterale

                ; cherche la variable dans la table
                call   cherche_variable

                cmp    bx, [v_indice_variable_suivante]
                jne    .affiche_valeur
                call   affiche_erreur
                oct    k_erreur_pas_cette_var

.affiche_valeur call   affiche_chaine_test
                asc    'VALEUR= '
                hex    00

                mov    ax, k_code_mov_dx_memoire
                call   genere_mot

                mov    ax, [v_indice_variable_courante]
                shl    ax, 1
                call   genere_mot
                mov    ax, k_adresse_affiche_hex_dx
                call   genere_call

                jmp_s  .fin

.chaine_litterale
                cmp    b [v_type_symbole], k_symbole_chaine_litterale
                call   affiche_erreur_if_ne
                oct    k_erreur_attend_nom_variable

                ; ?? traite affichage chaine littrale

.fin            call   lis_symbole
                call   a_la_ligne
                ret ; compile_interrogation



compile_arobas
                call   affiche_chaine_test
                asc    'COMPILE @ '
                hex    00

                ; x
                call   lis_symbole
                mov    al, [v_valeur_chiffre]
                xor    ah, ah
                seg    cs
                mov    [curseur_x], ax
                ; mov    dx, ax
                ; call   affiche_hex_dx

                ; saute la virgule
                call   lis_symbole

                ; y
                call   lis_symbole
                mov    al, [v_valeur_chiffre]
                seg    cs
                mov    [curseur_y], al

                ; call   affiche_hex_al
                ; call   stoppe

                call   lis_symbole
                call   a_la_ligne_test
                ret ; compile arobas



compile_say
                ; ?? mettre SAY variable
                call   affiche_chaine_test
                asc    'COMPILE SAY '
                hex    00

                call   lis_symbole
                cmp    b [v_type_symbole], k_symbole_chaine_litterale
                call   affiche_erreur_if_ne
                oct    k_erreur_attend_chaine_litterale

                ; affiche la chane littrale
                mov    bx, [v_debut_mot]
                mov    cx, [v_taille_mot]
.affiche        mov    al, [bx]
                call   affiche_car
                inc    bx
                loopne .affiche

                call   a_la_ligne_test
                call   lis_symbole
                ret ; compile_say



compile_affectation
                call   affiche_chaine_test
                asc    'COMPILE AFFECTATION '
                hex    00

                ; rcupre l'indice de la variable.
                ; si existe pas, place la taille, le nom et alloue
                call   cherche_variable

                ; si la variable n'existe pas, allouer cette variable
                cmp    bx, [v_indice_variable_suivante]
                jne    .calcule_valeur

                call   alloue_variable

.calcule_valeur ; lis =
                call   lis_symbole

                cmp    b [v_type_symbole], k_symbole_egal
                call   affiche_erreur_if_ne
                oct    k_erreur_attend_egal

                ; MOV [MEM], IMMEDIAT
                mov    ax, k_code_mov_w_memoire_immediat
                call   genere_mot
                mov    ax, [v_indice_variable_courante]
                shl    ax, 1
                call   genere_mot

                ; l'expression
                call   lis_symbole
                call   compile_expression

                ; met dans variable
                mov    al, [v_valeur_chiffre]
                xor    ah, ah
                call   genere_mot

                call   affiche_chaine_test
                asc    ' FIN AFFECTATION'
                hex    00

                ; compile_expression a lu le symbole aprs l'expression
                call   a_la_ligne_test
                ret ; compile_affectation



compile_if   ; n'accepte que: IF variable= 5 instruction
                call   affiche_chaine_test
                asc    'COMPILE IF'
                hex    00

                ; la condition: la variable
                call   lis_symbole
                cmp    b [v_type_symbole], k_symbole_variable
                call   affiche_erreur_if_ne
                oct    k_erreur_attend_nom_variable

                ; cherche la variable dans la table
                call   cherche_variable

                mov    dx, bx
                call   affiche_hex_dx

                cmp    bx, [v_indice_variable_suivante]
                jne    .comparaison
                call   affiche_erreur
                oct    k_erreur_pas_cette_var

.comparaison    ; lis =
                call   lis_symbole
                cmp    b [v_type_symbole], k_symbole_egal
                call   affiche_erreur_if_ne
                oct    k_erreur_attend_egal

                ; l'expression
                call   lis_symbole
                call   compile_expression

                ; compare les valeurs
                mov    al, [v_valeur_chiffre]
                mov    bx, [v_indice_variable_courante]
                add    bx, k_decalage_valeur
                cmp    [bx], al
                jne    .saute_then

                call   affiche_chaine_test
                asc    'COMPILE THEN'
                hex    00

.instructions   ; les instructions
                cmp    b [v_type_symbole], k_symbole_end_if
                je     .fin_if

                call   compile_instruction

                push   ax
                mov    al, 'i'
                call   affiche_car_test
                call   stoppe_test
                pop    ax
                jmp_s  .instructions

.saute_then     ; saute tout jusqu' ENDIF
                cmp    b [v_type_symbole], k_symbole_end_if
                je     .fin_if

                call   lis_symbole
                jmp_s  .saute_then

.fin_if         ; saute ENDIF
                call   lis_symbole

                ret ; compile_if



compile_get
                ret ; compile_get

compile_read
                ret ; compile_read

compile_input
                ret ; compile_input

compile_do
                ret ; compile_do

compile_while
                ret ; compile_while

compile_and
                ret ; compile_and

compile_create
                ret ; compile_create

compile_display
                ret ; compile_display




fin_cassasob
