; 018 iaecran
; 30 jul 91

;--------------------------------------
; librairie: affichage
;--------------------------------------

                data

k_segment_ecran equ     $B000



                code

curseur_x       hex     0000
curseur_y       hex     00
adr_k_deux      hex     0200 ; pour mul par 2



; affichage de base


affiche_hex_dx  push   dx
                push   ax

                mov    al, dh
                call   affiche_hex_al

                mov    al, dl
                call   affiche_hex_al

                pop    ax
                pop    dx
                ret    ; affiche_hex_dx



affiche_hex_al  push   ax

                mov    ah, al
                push   cx
                mov    cl, $04
                shr    al, cl
                pop    cx
                call   .force_minuscule
                mov    al, ah
                call   .force_minuscule

                pop    ax
                ret    ; affiche_hex_al

.force_minuscule
                and    al, $0F
                add    al, $90
                daa
                adc    al, $40
                daa



affiche_car     ; mul modifie dx !
                push   ax
                push   bx
                push   dx
                push   di
                push   ds
                push   es
                pushf

                ; met cs dans ds et es
                push   cs
                pop    ds
                push   cs
                pop    es

                ; suppr ascii fort
                and    al, $7F

                mov    bl, al
                mov    al, $50      ; 80 colonnes
                mul    b [curseur_y]
                add    ax, [curseur_x]
                mul    w  [adr_k_deux]
                ; shl   ax, 1
                mov    di, ax

                mov    ax, k_segment_ecran
                mov    es, ax

                seg    es
                mov    [di], bl

                inc    b [curseur_x]

                mov    al, [curseur_x]
                cmp    al, $50
                jl     .affiche_car_1

                call   a_la_ligne

.affiche_car_1  popf
                pop    es
                pop    ds
                pop    di
                pop    dx
                pop    bx
                pop    ax
                ret    ; affiche_car



a_la_ligne
                push   ax
                push   ds

                push   cs
                pop    ds

                cmp    b [curseur_y], $17 ; ligne 25
                jle    .a_la_ligne1

                call   deroule_ecran

                mov    b [curseur_x], $00
                jmp_s  .a_la_ligne2

.a_la_ligne1    mov    b [curseur_x], $00
                inc    b [curseur_y]

.a_la_ligne2    pop    ds
                pop    ax
                ret    ; a_la_ligne




deroule_ecran
                push   ax
                push   cx
                push   si

                push   di
                push   ds
                push   es

                ; initialise es et ds
                mov    ax, k_segment_ecran
                mov    es, ax
                mov    ds, ax

                mov    si, $00A0
                mov    di, $0000

                ; 80* 24
                mov    cx, $0780
                rep
                movs   w

                ; remplis la derniere ligne avec des points
                mov    al, '.'
                mov    ah, $07
                ; 80 car par ligne
                mov    cx, $0050
                rep
                stos   w

                pop    es
                pop    ds
                pop    di
                pop    si
                pop    cx
                pop    ax
                ret    ; deroule_ecran



initialise_curseur
                seg    cs
                mov    b [curseur_x], $00
                seg    cs
                mov    b [curseur_y], $00
                ret    ; initialise_curseur



clrscr          push   es
                push   di

                mov    ax, k_segment_ecran
                mov    es, ax

                mov    di, $0000
                mov    al, '.'
                mov    ah, $07

                mov    cx, $07D0  ; 2000 caracteres= 25*80

                cld
                rep
                stos   w

                pop    di
                pop    es
                ret    ; clrscr



affiche_espace  push   ax

                mov    al, ' '
                call   affiche_car

                pop    ax
                ret    ; affiche_espace




affiche_n_espace
                ; CX contient le nombre d'espaces  afficher
                call   affiche_espace
                loop   affiche_n_espace
                ret    ; affiche_n_espaces



affiche_chaine  ; affiche une chane situe aprs le CALL
                ; et termine par 0

                seg    cs
                mov    [v_sauve_bx], bx
                seg    cs
                mov    [v_sauve_ax], ax

                ; rcupre l'emplacement de la chaine
                pop    bx

.affiche        seg    cs
                mov    al, [bx]

                inc    bx

                cmp    al, $00
                je     .ret

                call   affiche_car
                jmp_s  .affiche

.ret            ; veut revenir apres la chaine
                push   bx

                seg    cs
                mov    bx, [v_sauve_bx]
                seg    cs
                mov    ax, [v_sauve_ax]

                ret    ; affiche_chaine

v_sauve_bx      hex 0000
v_sauve_ax      hex 0000



affiche_chaine_0
                ; affiche une chane situe  DS:SI
                ; et termine par 0
                push   ax

.affiche        lods   b

                cmp    al, $00
                je     .ret

                call   affiche_car
                jmp_s  .affiche

.ret            pop    ax
                ret    ; affiche_chaine_0


; fin iaecran

