(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)


      procedure traite_point_interrogation;
        var l_premier: boolean;
        begin
          with g_interprete, g_sortie do
          begin
            genere_debut_ligne(0, 'WRITELN(');
            l_premier:= true;
            lis_symbole(p_pt_programme);
            repeat
              if l_premier
                then l_premier:= false
                else genere(', ');
              traite_expression;
              genere(l_texte_expression);
            until type_symbole= symbole_retour_chariot;
            genere_fin_ligne(');');
          end; 
        end; 

      procedure traite_WRITE;
        var l_premier: boolean;
        begin
          with g_interprete, g_sortie do
          begin
            genere_debut_ligne(0, 'WRITE(');
            l_premier:= true;
            lis_symbole(p_pt_programme);
            repeat
              if l_premier
                then l_premier:= false
                else genere(', ');
              traite_expression;
              genere(l_texte_expression);
            until type_symbole= symbole_retour_chariot;
            genere_fin_ligne(');');
          end; 
        end; 

      procedure traite_affectation;
        var l_nom_variable: string;

        procedure affecte_expression;
          begin
            with g_interprete, table_variables[indice_variable_courante].pt_descripteur^ do
            begin
              case type_expression of
                'C' : begin
                        if type_zone= '?'
                          then type_zone:= 'C'
                          else
                            if type_zone<> 'C'
                              then affiche_erreur_programme(p_pt_programme,
                                 'affecte '+ type_zone+ '= C');
                        genere_debut_ligne(0, 'stocke_chaine('
                           + f_entier_chaine(indice_variable_courante)
                           + ', '+ l_texte_expression+ ')');
                      end;
                'N' : begin
                        if type_zone= '?'
                          then type_zone:= 'N'
                          else
                            if type_zone<> 'N'
                              then affiche_erreur_programme(p_pt_programme,
                                 'affecte '+ type_zone+ '= N');
                        genere_debut_ligne(0, f_variable+ ':= '+ l_texte_expression);
                      end;
                else affiche_erreur_programme(p_pt_programme,
                    'expression de type inconnu '+ type_expression);
              end; 
            end; 
          end; 

        procedure traite_SPACE;
          begin
            with g_interprete do
            begin
              lis_symbole(p_pt_programme);
              if type_symbole= symbole_parenthese_ouvrante
                then begin
                    lis_symbole(p_pt_programme);
                    if type_symbole= symbole_nombre_constant
                      then begin
                          fillchar(valeur_expression_chaine[1],
                              round(valeur_numerique_symbole), ' ');
                          valeur_expression_chaine[0]:=
                              chr(round(valeur_numerique_symbole));
                          l_texte_expression:= ''''+ valeur_expression_chaine+ '''';
                          type_expression:= 'C';
                          affecte_expression;
                        end
                      else affiche_erreur_programme(p_pt_programme,
                          'attend valeur numrique '+ type_expression);
                    lis_symbole(p_pt_programme);
                  end
                else affiche_erreur_programme(p_pt_programme, 'attend (');
            end; 
          end; 

        begin 
          with g_interprete do
          begin
            if not f_variable_existe
              then alloue_variable;
            lis_symbole(p_pt_programme);
            if type_symbole= symbole_egal
              then begin
                  lis_symbole(p_pt_programme);
                  case type_symbole of
                    symbole_SPACE : traite_SPACE;
                    symbole_chaine_constante, symbole_nombre_constant,
                      symbole_parenthese_ouvrante,
                      symbole_variable : begin
                                           traite_expression;
                                           affecte_expression;
                                         end;
                    else
                      affiche_erreur_programme(p_pt_programme, 'erreur d''affectation');
                  end; 
                end
              else affiche_erreur_programme(p_pt_programme, 'aprs '+ l_nom_variable+ ' attend =');
            genere_fin_ligne(';');
          end; 
        end; 

      procedure traite_DISPLAY;
        begin
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            if type_symbole= symbole_MEMORY
              then genere_ligne(0, 'affiche_variables('
                 + f_entier_chaine(indice_variable_max)+ ');')
              else affiche_erreur_programme(p_pt_programme, 'attend MEMORY');
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_INPUT;
        var l_chaine: string;
            l_taille_chaine: integer;
            l_erreur: integer;

        procedure lis_variable_de_type_inconnu;
          var l_reel: real;
          begin
            with g_interprete do
            begin
              genere_ligne(0, 'WITH g_table_variables['
                  + f_entier_chaine(indice_variable_courante)+ ']^ DO');
              genere_ligne(2, 'BEGIN');
              genere_ligne(0, 'VAL(g_chaine, valeur_numerique, g_erreur);');
              genere_ligne(0, 'IF (g_erreur= 0) AND (LENGTH(g_chaine)<> 0)');
              genere_ligne(0, '  THEN type_zone:= ''N''');
              genere_ligne(0, '  ELSE type_zone:= ''C''');
              genere_ligne(-2, 'END;');
            end; 
          end; 

        begin 
          with g_interprete, g_sortie do
          begin
            lis_symbole(p_pt_programme);
            if type_symbole= symbole_chaine_constante
              then begin
                  genere_ligne(0, 'WRITE('''+ texte_symbole+ ''');');
                  lis_symbole(p_pt_programme);
                end;
            if type_symbole= symbole_TO
              then begin
                  lis_symbole(p_pt_programme);
                  if type_symbole= symbole_variable
                    then begin
                        if not f_variable_existe
                          then alloue_variable;
                        genere_ligne(0, 'READLN(g_chaine);');
                        l_taille_chaine:= length(l_chaine);
                        genere_ligne(0, 'stocke_chaine('
                          + f_entier_chaine(indice_variable_courante)
                          + ', g_chaine);');
                        with table_variables[indice_variable_courante].pt_descripteur^ do
                          case type_zone of
                            'C' :  ;
                            'N' : begin
                                    genere_ligne(0, 'VAL(g_chaine, '+ f_variable
                                        + ', g_erreur);');
                                  end;
                            else lis_variable_de_type_inconnu;
                          end; 
                      end
                    else affiche_erreur_programme(p_pt_programme,
                        'attend un nom de variable');
                end
              else affiche_erreur_programme(p_pt_programme, 'attend TO');
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_arobas;
        var l_ligne, l_colonne: integer;

        procedure traite_SAY;
          begin
            with g_interprete, g_sortie do
            begin
              genere_debut_ligne(0, 'WRITE(');
              lis_symbole(p_pt_programme);
              traite_expression;
              genere_fin_ligne(l_texte_expression+ ');');
            end; 
          end; 

        begin 
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            traite_expression;
            genere_debut_ligne(0, 'GOTOXY(ROUND('+ l_texte_expression);
            if type_symbole<> symbole_virgule
              then affiche_erreur_programme(p_pt_programme, 'attend ,');
            lis_symbole(p_pt_programme);
            genere('), ROUND(');
            traite_expression;
            genere_fin_ligne(l_texte_expression+ '));');
            case type_symbole of
              symbole_SAY : traite_SAY;
            end; 
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_RELEASE;
        begin
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            if f_variable_existe
              then begin
                  with g_interprete do
                    table_variables[indice_variable_courante].proprietaire[1]:= '*';
                end
              else affiche_erreur_programme(p_pt_programme,
                  'variable '+ texte_symbole+ 'n''existe pas');
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure purge_fin_ligne_return;
        begin
          with g_interprete do
          begin
            while type_symbole<> symbole_retour_chariot do
              lis_symbole(p_pt_programme);
            while type_symbole= symbole_retour_chariot do
              lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_IF;
        begin
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            genere_debut_ligne(0, 'IF ');
            traite_condition;
            genere_fin_ligne('');
            genere_ligne(2, 'THEN BEGIN');
            g_sortie.colonne_sortie:= g_sortie.colonne_sortie+ 4;
            traite_instructions(p_pt_programme,
                [symbole_fin, symbole_ELSE, symbole_ENDIF],
                p_nom_proprietaire);
            if type_symbole= symbole_ELSE
              then begin
                  genere_ligne(-2, 'END');
                  genere_ligne(-2, 'ELSE BEGIN');
                  g_sortie.colonne_sortie:= g_sortie.colonne_sortie+ 4;
                  purge_fin_ligne_RETURN;
                  traite_instructions(p_pt_programme,
                      [symbole_fin, symbole_ELSE, symbole_ENDIF],
                      p_nom_proprietaire);
                end;
            genere_ligne(-2, 'END;');
            g_sortie.colonne_sortie:= g_sortie.colonne_sortie- 4;
            purge_fin_ligne_return;
          end; 
        end; 
      procedure traite_WHILE;
        begin
          with g_interprete do
          begin
            genere_debut_ligne(0, 'WHILE ');
            lis_symbole(p_pt_programme);
            traite_condition;
            genere_fin_ligne(' DO');
            genere_ligne(0, 'BEGIN');
            g_sortie.colonne_sortie:= g_sortie.colonne_sortie+ 2;
            traite_instructions(p_pt_programme, [symbole_fin, symbole_ENDDO],
                 p_nom_proprietaire);
            genere_ligne(-2, 'END;');
            purge_fin_ligne_return;
          end; 
        end; 
      procedure traite_DO;
        begin 
          lis_symbole(p_pt_programme);
          case g_interprete.type_symbole of
            symbole_while : traite_WHILE;
          end; 
        end; 
      procedure traite_CLEAR;
        begin 
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            if type_symbole in [symbole_retour_chariot, symbole_SCREEN]
              then 
                   genere_ligne(0, 'clrscr;');
            if type_symbole in [symbole_retour_chariot, symbole_MEMORY]
              then 
                    g_interprete.indice_variable_libre:= 0;
            if type_symbole<> symbole_retour_chariot
              then lis_symbole(p_pt_programme);
          end; 
        end; 
      procedure traite_STOPPE;
        begin
          genere_ligne(0, 'WRITE(READKEY);');
          lis_symbole(p_pt_programme);
        end; 
