(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

  VAR g_table_variables: ARRAY[0..100] OF t_pt_descripteur_de_zone;
      g_table_valeurs_chaines: ARRAY[0..2000] OF CHAR;
      g_indice_valeur_variable_suivante: integer;
      g_chaine: string;
      g_erreur: integer;

  procedure alloue_variables;
    var l_variable: integer;
    begin
      for l_variable:= 0 to 100 do
        new(g_table_variables[l_variable]);
      g_indice_valeur_variable_suivante:= 0;
    end; 

  procedure stocke_chaine(p_indice_variable: integer; p_chaine: string);
    var l_pt_valeur: t_pt_valeur_zone;
        l_taille: integer;
    begin
      l_taille:= length(p_chaine);
        if g_indice_valeur_variable_suivante+ l_taille<= 2000
          then begin
              with g_table_variables[p_indice_variable]^ do
              begin
                pt_valeur_zone:= addr(g_table_valeurs_chaines[g_indice_valeur_variable_suivante]);
                taille_zone:= l_taille;
                if l_taille> 0
                  then move(p_chaine[1], pt_valeur_zone^, l_taille);
              end; 
              g_indice_valeur_variable_suivante:= g_indice_valeur_variable_suivante
                + l_taille;
            end
          else
            affiche_erreur('plus de place valeurs variables');
      end; 

  function f_extrais_chaine(p_indice_variable: integer): string;
    var l_chaine: string;
    begin
      with g_table_variables[p_indice_variable]^ do
      begin
        if taille_zone> 0
          then move(pt_valeur_zone^, l_chaine[1], taille_zone);
        l_chaine[0]:= chr(taille_zone);
        f_extrais_chaine:= l_chaine;
      end; 
    end; 

  procedure affiche_variables(p_indice_variable_max: integer);
    var l_indice_variable: integer;

    procedure affiche_valeur_variable(p_indice_variable: integer);
      begin
        with g_table_variables[p_indice_variable]^, g_sortie do
          case type_zone of
            'N' : write(sortie, valeur_numerique);
            'C', 'L' : affiche_chaine_0_fixe(pt_valeur_zone^, taille_zone);
            'D' : ; 
          end; 
      end; 

    begin
      if wherex<> 1
        then writeln;
      for l_indice_variable:= 1 to p_indice_variable_max do
        affiche_valeur_variable(l_indice_variable);
    end; 
